loadkeys:
		and dx,dx			
		jne loadkeys_ret
		cmp ax,256
		jne loadkeys_ret
		mov bx,trackbuf
		mov cx,1			
		call getfssec
		mov si,trackbuf
		mov di,KbdMap
		mov cx,256 >> 2
		rep movsd

loadkeys_ret:	
		ret
		
get_msg_file:
		push es
		shl edx,16			
		mov dx,ax
		mov ax,xfer_buf_seg		
		mov es,ax
		mov byte [TextAttribute],07h	
		mov byte [DisplayMask],07h	
		call msg_initvars

get_msg_chunk:  
		push edx			
		xor bx,bx			
		mov cx,[BufSafe]
		call getfssec
		pop edx
		push si				
		xor si,si			
		mov cx,[BufSafeBytes]		

print_msg_file:
		push cx
		push edx
		es lodsb
		cmp al,1Ah                      
		je msg_done_pop
		push si
		mov cl,[UsingVGA]
		inc cl				
		call [NextCharJump]		
		pop si
		pop edx
		pop cx
		dec edx
		jz msg_done
		loop print_msg_file
		pop si
		jmp short get_msg_chunk

msg_done_pop:
		add sp,byte 6			

msg_done:
		pop si
		pop es
		ret

msg_putchar:                                    
		cmp al,0Fh                      
		je msg_ctrl_o
		cmp al,0Dh                      
		je msg_ignore
		cmp al,0Ah                      
		je msg_newline
		cmp al,0Ch                      
		je msg_formfeed
		cmp al,19h			
		je msg_novga
		cmp al,18h			
		je msg_vga
		jnb .not_modectl
		cmp al,10h			
		jae msg_modectl

.not_modectl:

msg_normal:	
		call write_serial_displaymask	
		test [DisplayMask],cl
		jz msg_ignore			
		mov bx,[TextAttrBX]
		mov ah,09h                      
		mov cx,1                        
		int 10h                         
		mov al,[CursorCol]
		inc ax
		cmp al,[VidCols]
		ja msg_line_wrap		
		mov [CursorCol],al

msg_gotoxy:     
		mov bh,[TextPage]
		mov dx,[CursorDX]
		mov ah,02h                      
		int 10h

msg_ignore:
		ret

msg_ctrl_o:                                     
		mov word [NextCharJump],msg_setbg
		ret

msg_newline:                                    
		mov si,crlf_msg
		call write_serial_str_displaymask

msg_line_wrap:					
		test [DisplayMask],cl
		jz msg_ignore
		mov byte [CursorCol],0
		mov al,[CursorRow]
		inc ax
		cmp al,[VidRows]
		ja msg_scroll
		mov [CursorRow],al
		jmp short msg_gotoxy

msg_scroll:     
		xor cx,cx                       
		mov dx,[ScreenSize]
		mov [CursorRow],dh		
		mov bh,[ScrollAttribute]
		mov ax,0601h                    
		int 10h
		jmp short msg_gotoxy

msg_formfeed:                                   
		mov si,crff_msg
		call write_serial_str_displaymask
		test [DisplayMask],cl
		jz msg_ignore
		xor cx,cx
		mov [CursorDX],cx		
		mov dx,[ScreenSize]
		mov bh,[TextAttribute]
		mov ax,0600h                    
		int 10h
		jmp msg_gotoxy

msg_setbg:                                      
		call unhexchar
		jc msg_color_bad
		shl al,4
		test [DisplayMask],cl
		jz .dontset
		mov [TextAttribute],al

.dontset:
		mov word [NextCharJump],msg_setfg
		ret

msg_setfg:                                      
		call unhexchar
		jc msg_color_bad
		test [DisplayMask],cl
		jz .dontset
		or [TextAttribute],al		

.dontset:
		jmp short msg_putcharnext

msg_vga:
		mov word [NextCharJump],msg_filename
		mov di, VGAFileBuf
		jmp short msg_setvgafileptr

msg_color_bad:
		mov byte [TextAttribute],07h	

msg_putcharnext:
		mov word [NextCharJump],msg_putchar
		ret

msg_filename:					
		cmp al,0Ah			
		je msg_viewimage
		cmp al,' '
		jbe msg_ret			
		mov di,[VGAFilePtr]
		cmp di,VGAFileBufEnd
		jnb msg_ret
		mov [di],al			
		inc di

msg_setvgafileptr:
		mov [VGAFilePtr],di

msg_ret:	
		ret

msg_novga:
		call vgaclearmode
		jmp short msg_initvars

msg_viewimage:
		push es
		push ds
		pop es				
		mov si,VGAFileBuf
		mov di,VGAFileMBuf
		push di
		call mangle_name
		pop di
		call searchdir
		pop es
		jz msg_putcharnext		
		call vgadisplayfile
		
msg_initvars:
		pusha
		mov bh,[TextPage]
		mov ah,03h                      
		int 10h
		mov [CursorDX],dx
		popa
		jmp short msg_putcharnext	

msg_modectl:
		and al,07h
		mov [DisplayMask],al
		jmp short msg_putcharnext

write_serial_displaymask:
		test byte [DisplayMask], 04h
		jz write_serial.end

write_serial:
		pushfd
		pushad
		mov bx,[SerialPort]
		and bx,bx
		je .noserial
		push ax
		mov ah,[FlowInput]

.waitspace:
		lea dx,[bx+5]			
		in al,dx
		test al,20h
		jz .waitspace
		inc dx				
		in al,dx
		and al,ah
		cmp al,ah
		jne .waitspace	

.no_flow:		
		xchg dx,bx			
		pop ax
		call slow_out			

.noserial:	
		popad
		popfd

.end:		
		ret

write_serial_str_displaymask:
		test byte [DisplayMask], 04h
		jz write_serial_str.end

write_serial_str:
.loop		lodsb
		and al,al
		jz .end
		call write_serial
		jmp short .loop
.end:		ret

pollchar:
		pushad
		mov ah,1		
		int 16h
		jnz .done		
		mov dx,[SerialPort]
		and dx,dx
		jz .done		
		add dx,byte 5		
		in al,dx
		test al,1		
		jz .done
		inc dx			
		mov ah,[FlowIgnore]	
		in al,dx
		and al,ah
		cmp al,ah
		setne al
		dec al			

.done:		
		popad
		ret

getchar:
.again:		
		mov ah,1		
		int 16h
		jnz .kbd		
		mov bx,[SerialPort]
		and bx,bx
		jz .again
		lea dx,[bx+5]		
		in al,dx
		test al,1
		jz .again
		inc dx			
		mov ah,[FlowIgnore]
		in al,dx
		and al,ah
		cmp al,ah
		jne .again

.serial:	
		xor ah,ah		
		xchg dx,bx		
		in al,dx
		ret

.kbd:		
		xor ax,ax		
		int 16h
		and al,al
		jz .func_key
		mov bx,KbdMap		
		xlatb

.func_key:	
		ret

%ifdef DEBUG_TRACERS

debug_tracer:	
		pushad
		pushfd
		mov bp,sp
		mov bx,[bp+9*4]		
		mov al,[cs:bx]		
		inc word [bp+9*4]	
		call writechr
		popfd
		popad
		ret
%endif	
