vgadisplayfile:
		mov [VGACluster],si
		push es
		call vgaclearmode
		call vgasetmode
		jnz .error_nz

.graphalready:
		mov ax,xfer_buf_seg		
		mov es,ax
		mov fs,ax
		call vgagetchunk		
		cmp dword [es:xbs_vgabuf],0x1413f33d	
.error_nz:	jne .error
		mov ax,[es:xbs_vgabuf+4]
		mov [GraphXSize],ax
		mov dx,xbs_vgabuf+8		
		mov ax,1012h			
		xor bx,bx			
		mov cx,16			
		int 10h
	
.movecursor:
		mov ax,[es:xbs_vgabuf+6]	
		mov dx,[VGAFontSize]
		add ax,dx
		dec ax
		div dl
		xor dx,dx			
		cmp al,[VidRows]
		jb .rowsok
		mov al,[VidRows]
		dec al
.rowsok:
		mov dh,al
		mov ah,2
		xor bx,bx
		int 10h				
		mov cx,[es:xbs_vgabuf+6]	
		mov si,xbs_vgabuf+8+3*16	
		mov word [VGAPos],0

.drawpixelrow:
		push cx
		mov cx,[GraphXSize]
		mov di,xbs_vgatmpbuf		
		call rledecode			
		push si
		mov si,xbs_vgatmpbuf
		mov di,si
		add di,[GraphXSize]
		mov cx,640/4
		xor eax,eax
		rep stosd			
		mov di,0A000h			
		mov es,di
		mov di,[VGAPos]
		mov bp,640
		call packedpixel2vga
		add word [VGAPos],byte 80	
		push fs
		pop es
		pop si
		pop cx
		loop .drawpixelrow

.error:
		pop es
		ret

rledecode:
		shl esi,1		
		xor dl,dl		
.loop:
		call .getnybble
		cmp al,dl
		je .run			
		stosb
		mov dl,al
		dec cx
		jnz .loop
.done:
		shr esi,1
		adc si,byte 0
		ret
.run:
		xor bx,bx
		call .getnybble
		and al,al
		jz .longrun
		mov bl,al
.dorun:
		push cx
		mov cx,bx
		mov al,dl
		rep stosb
		pop cx
		sub cx,bx
		ja .loop
		jmp short .done
.longrun:
		call .getnybble
		mov ah,al
		call .getnybble
		shl al,4
		or al,ah
		mov bl,al
		add bx,16
		jmp short .dorun
.getnybble:
		shr esi,1
		fs lodsb
		jc .high
		dec si
		and al,0Fh
		stc
		rcl esi,1
		ret
.high:
		shr al,4
		cmp si,xbs_vgabuf+trackbufsize	
		jb .nonewchunk
		call vgagetchunk
		mov si,xbs_vgabuf		
.nonewchunk:
		shl esi,1
		ret

vgagetchunk:
		pushad
		mov si,[VGACluster]
		and si,si
		jz .eof				
		mov cx,[BufSafe]		
		mov bx,xbs_vgabuf
		call getfssec
		jnc .noteof
		xor si,si
.noteof:	mov [VGACluster],si

.eof:		popad
		ret

packedpixel2vga:
		mov dx,3C4h	
		mov al,2	
		out dx,al	
		inc dx		
		mov al,1
		mov bl,al
.planeloop:
		pusha
		out dx,al
.loop1:
		mov cx,8
.loop2:
		xchg cx,bx
		fs lodsb
		shr al,cl
		rcl ch,1	
		xchg cx,bx
		loop .loop2
		mov al,bh
		stosb
		sub bp,byte 8
		ja .loop1
		popa
		inc bl
		shl al,1
		cmp bl,4
		jbe .planeloop
		ret

vgasetmode:
		push ds
		pop es
		mov ax,1A00h		
		xor bx,bx
		int 10h
		sub bl, 7		
		cmp bl, 1
		ja .error		
		mov ax,0012h		
		int 10h
		mov dx,linear_color
		mov ax,1002h		
		int 10h
		mov [UsingVGA], byte 1
		call use_font		
		mov byte [ScrollAttribute], 00h
		xor ax,ax		
.error:
		ret

vgaclearmode:
		push ds
		push es
		pushad
		mov ax,cs
		mov ds,ax
		mov es,ax
		cmp [UsingVGA], byte 1
		jne .done
		mov ax,0003h		
		int 10h
		mov [UsingVGA], byte 0
		call use_font		
		mov byte [ScrollAttribute], 07h
.done:
		popad
		pop es
		pop ds
		ret

vgashowcursor:
		pushad
		mov al,'_'
		jmp short vgacursorcommon
vgahidecursor:
		pushad
		mov al,' '
vgacursorcommon:
		cmp [UsingVGA], byte 1
		jne .done
		mov ah,09h
		mov bx,0007h
		mov cx,1
		int 10h
.done:
		popad
		ret

linear_color	db 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 0
UsingVGA	db 0

