call parse_config		
no_config_file:

check_for_key:
		cmp word [ForcePrompt],byte 0	
		jnz enter_command
		test byte [KbdFlags],5Bh	
		jz auto_boot			

enter_command:
		mov si,boot_prompt
		call cwritestr
		mov byte [FuncFlag],0		
		mov di,command_line

clear_buffer:	
		mov ah,1			
		int 16h
		jz get_char_time
		xor ax,ax			
		int 16h
		jmp short clear_buffer

get_char_time:	
		call vgashowcursor
		mov cx,[KbdTimeOut]
		and cx,cx
		jz get_char			
		inc cx				
						
time_loop:	
		push cx

tick_loop:	
		push dx
		call pollchar
		jnz get_char_pop
		mov dx,[BIOS_timer]		
		pop ax
		cmp dx,ax			
		je tick_loop
		pop cx
		loop time_loop			
		call vgahidecursor
		jmp command_done		

get_char_pop:	
		pop eax				

get_char:
		call vgashowcursor
		call getchar
		call vgahidecursor
		and al,al
		jz func_key

got_ascii:	
		cmp al,7Fh			
		je backspace
		cmp al,' '			
		jb not_ascii
		ja enter_char
		cmp di,command_line		
		je short get_char

enter_char:	
		test byte [FuncFlag],1
		jz .not_ctrl_f
		mov byte [FuncFlag],0
		cmp al,'0'
		jb .not_ctrl_f
		je ctrl_f_0
		cmp al,'9'
		jbe ctrl_f

.not_ctrl_f:	
		cmp di,max_cmd_len+command_line 
		jnb short get_char
		stosb				
		call writechr			
		jmp short get_char

not_ascii:	
		mov byte [FuncFlag],0
		cmp al,0Dh			
		je command_done
		cmp al,06h			
		je set_func_flag
		cmp al,16h			
		je print_version
		cmp al,08h			
		jne get_char

backspace:	
		cmp di,command_line		
		je get_char			
		dec di				
		mov si,wipe_char		
		call cwritestr
		jmp short get_char_2

set_func_flag:
		mov byte [FuncFlag],1

get_char_2:
		jmp short get_char

ctrl_f_0:	
		add al,10			

ctrl_f:		
		sub al,'1'
		xor ah,ah
		jmp short show_help

func_key:
		xchg al,ah
		cmp al,68			
		ja short get_char_2
		sub al,59			
		jb short get_char_2

show_help:	
		push di				
		shl ax,FILENAME_MAX_LG2		
		add ax,FKeyName
		xchg di,ax
		cmp byte [di],NULLFILE
		je short fk_nofile		
		call searchdir
		jz short fk_nofile		
		push si
		call crlf
		pop si
		call get_msg_file
		jmp short fk_wrcmd

print_version:
		push di				
		call cwritestr
		call cwritestr
		
fk_wrcmd:
		mov si,boot_prompt
		call cwritestr
		pop di				
		push di
		mov byte [di],0			
		mov si,command_line
		call cwritestr			

fk_nofile:	
		pop di
		jmp short get_char_2

auto_boot:
		mov si,default_cmd
		mov di,command_line
		mov cx,(max_cmd_len+4) >> 2
		rep movsd
		jmp short load_kernel

command_done:
		call crlf
		cmp di,command_line		
		je auto_boot
		xor al,al			
		stosb

load_kernel:					
		mov si,command_line
		mov di,KernelName
		push si
		push di
		call mangle_name
		pop di
		pop si

clin_non_wsp:   
		lodsb
		cmp al,' '
		ja clin_non_wsp

clin_is_wsp:    
		and al,al
		jz clin_opt_ptr
		lodsb
		cmp al,' '
		jbe clin_is_wsp

clin_opt_ptr:   
		dec si                          
		mov [CmdOptPtr],si		
		mov cx,[VKernelCtr]
		push ds
		push word vk_seg
		pop ds
		cmp cx,byte 0
		je not_vk
		xor si,si			

vk_check:	
		pusha
		mov cx,FILENAME_MAX
		repe cmpsb			
		je vk_found
		popa
		add si,vk_size
		loop vk_check

not_vk:		
		pop ds
		cmp word [AllowImplicit],byte 0
		je bad_implicit
		push es
		push si
		push di
		mov di,real_mode_seg
		mov es,di
		mov si,AppendBuf
		mov di,cmd_line_here
		mov cx,[AppendLen]
		rep movsb
		mov [CmdLinePtr],di
		pop di
		pop si
		pop es

get_kernel:     
		mov byte [KernelName+FILENAME_MAX],0	
%if IS_SYSLINUX || IS_MDSLINUX			
		mov eax,[KernelName+8]		
		mov [exten_table_end],eax	
%else
		mov di,KernelName
		xor al,al
		mov cx,FILENAME_MAX-5		
		repne scasb			
		jne .no_skip
		dec di				
.no_skip:	
		mov [KernelExtPtr],di
%endif
		mov bx,exten_table
.search_loop:	
		push bx
		mov di,KernelName	      	
		call searchdir
		pop bx
		jnz kernel_good
		mov eax,[bx]			
%if IS_SYSLINUX || IS_MDSLINUX
		mov [KernelName+8],eax
%else
		mov si,[KernelExtPtr]
		mov [si],eax
		mov byte [si+4],0
%endif
		add bx,byte 4
		cmp bx,exten_table_end
		jna .search_loop		

bad_kernel:     
		mov si,KernelName
		mov di,KernelCName
		push di
		call unmangle_name              
		mov si,err_notfound		
		call cwritestr
		pop si				
		call cwritestr
		mov si,crlf_msg
		jmp abort_load                  

bad_implicit:   
		mov si,KernelName		
		mov di,KernelCName
		call unmangle_name
		jmp short bad_kernel

vk_found:	
		popa
		push di
		mov di,VKernelBuf
		mov cx,vk_size >> 2
		rep movsd
		push es				
		pop ds
		push es
		push word real_mode_seg
		pop es
		mov di,cmd_line_here
		mov si,VKernelBuf+vk_append
		mov cx,[VKernelBuf+vk_appendlen]
		rep movsb
		mov [CmdLinePtr],di		
		pop es
		pop di                          
		push di	
		mov si,VKernelBuf+vk_rname
		mov cx,FILENAME_MAX		
		rep movsb
		pop di
%if IS_PXELINUX
		mov al,[VKernelBuf+vk_ipappend]
		mov [IPAppend],al
%endif
		xor bx,bx			
%if IS_SYSLINUX || IS_MDSLINUX
		jmp get_kernel
%else
		cmp byte [VKernelBuf+vk_rname], 0
		jne get_kernel		
		mov ax, [VKernelBuf+vk_rname+1]
		jmp local_boot
%endif

kernel_corrupt: 
		mov si,err_notkernel
		jmp abort_load

kernel_good:
		pusha
		mov si,KernelName
		mov di,KernelCName
		call unmangle_name
		sub di,KernelCName
		mov [KernelCNameLen],di
		popa
%if IS_SYSLINUX || IS_MDSLINUX
		mov ecx,[KernelName+7]
		mov cl,'.'
%else
		push di
		push ax
		mov di,KernelName
		xor al,al
		mov cx,FILENAME_MAX
		repne scasb
		jne .one_step
		dec di
.one_step:	mov ecx,[di-4]			
		pop ax
		pop di
%endif
		or ecx,20202000h		
		cmp ecx,'.com'
		je is_comboot_image
		cmp ecx,'.cbt'
		je is_comboot_image
		cmp ecx,'.c32'
		je is_com32_image
%if IS_ISOLINUX
		cmp ecx,'.img'
		je is_disk_image
%endif
		cmp ecx,'.bss'
		je is_bss_sector
		cmp ecx,'.bin'
		je is_bootsector
%if IS_SYSLINUX || IS_MDSLINUX
		cmp ecx,'.bs '
		je is_bootsector
		cmp ecx,'.0  '
		je is_bootsector
%else
		shr ecx,8
		cmp ecx,'.bs'
		je is_bootsector
		shr ecx,8
		cmp cx,'.0'
		je is_bootsector
%endif


