#ifndef DR_DAEMON
#define DR_DAEMON
#endif

static const char drseek_c[] = "$Header:";

#include "thincore/sys.h"
#include "thincore/net.h"
#include "thincore/ndmpserver.h"
#include "ndmp/ndmps.h"
#include "../dr/drdefs.h"
#include "drdevice.h"
#include <errno.h>

#ifdef __linux__
#include <sys/syscall.h>

#ifdef HAVE_LLSEEK
#include <syscall.h>
#else

#include <linux/unistd.h>

/*
static int  _llseek
(
 uint, 
 ulong, 
 ulong, 
 uint64 *, 
 uint
);
*/


#ifdef SYS__llseek

/*
static _syscall5
(
 int,      _llseek,
 uint,     uiFd,
 ulong,    ullOffset_high,
 ulong,    ullOffset_low,
 uint64 *, ullResult,
 uint,     uiORG
)
*/

#define _llseek(fd, hi, lo, res, wh) syscall(SYS__llseek, fd, hi, lo, res, wh)

#else

/*
** ===========================================================================
** ===========================================================================
*/
static int _llseek (uint Fd, ulong lBitHigh, ulong lBitLow, uint64 *llResult, uint iORG) 
{
	errno = ENOSYS;
	return -1;
}

#endif

/*
** ===========================================================================
** ===========================================================================
*/
static uint64 LocalSeek (uint uiFd, uint64 ullOffset, uint uiORG)
{
	uint64					ullResult;
	int							iRC;
	unsigned long 	ulHigh 	= (unsigned long)(ullOffset >> 32);
	unsigned long 	ulLow 	= (unsigned long)(ullOffset);

	iRC = _llseek (uiFd, ulHigh, ulLow, &ullResult, uiORG);

	return (iRC == (-1) ? (uint64)(int64)(-1) : ullResult);
}

#endif






/*
** ===========================================================================
** ===========================================================================
*/
EXTERN BooleanT DrSeek (int lFd, uint64 llSeekPos)
{
	BooleanT  bSuccess  = FALSE;
	uint64    llSeekRC  = 0;
	long      lErr      = 0;

	llSeekRC = lseek64 (lFd, llSeekPos, SEEK_SET);
	lErr     = errno;

	if (-1 == llSeekRC)
	{
		DRTRACE("ERROR: Faled to seek. Pos: [%llu] [%s]", DR_STR_ERR (lErr));
	}
	else 
	{
		/*
		DRTRACE("Seek OK. Seek Pos: [%llu], Current File Pos: [%llu]",
		llSeekPos, llSeekRC);
		*/

		bSuccess = TRUE;
	}

	return bSuccess;
}




#ifdef SYS_LINUX_KERNEL_OLD

/*
** ===========================================================================
** ===========================================================================
*/
EXTERN BooleanT DrSeek (int lFd, uint64 ullOffset)
{
	static BooleanT	bSeek 		= FALSE;
	BooleanT				bSuccess 	= FALSE;
	uint64					ullResult;

	if (TRUE != bSeek) 
	{
		ullResult = LocalSeek (lFd, ullOffset, SEEK_SET);

		if (-1 != ullResult)
		{
			bSuccess = TRUE;
		}
		else if (errno == ENOSYS)
		{
			bSeek = TRUE;
		}
	}

	if (TRUE == bSeek)
	{
		if ((sizeof(off_t) < sizeof(uint64)) && (ullOffset >= ((uint64) 1 << ((sizeof(off_t)*8) - 1))))
		{
			errno = EINVAL;
		}
		else if (0 <= lseek(lFd, (off_t) ullOffset, SEEK_SET))
		{
			bSuccess = TRUE;
		}
	}
	return bSuccess;
}
#endif

#endif
