static const char netcfg_c[] = "$Header:";

#include <stdio.h>
#include "netcfg.h"
#include <fcntl.h>
#include "../../x86/config/drtrace.h"

/* 
 * [TODO]
 * This file has a few routines copied from drprobe.c.
 * This is actually duplication of code, but its for now.
 * Later we can take these routine out in a common file and include in both places
 */


/*
** =======================================================================================
** =======================================================================================
*/

MODULE("DRGUI")



/* [TODO] Change this and display  a message Box */
int DisplayMsg (char * msg)
{
	quick_message (msg);
}

BooleanT ValidateIfParm (char *pstr)
{
  int   bSuccess  = FALSE;
  long  lIpA         = 0;
  long  lIpB         = 0;
  long  lIpC         = 0;
  long  lIpD         = 0;

  TRACE(("Validate Interface Parm: %s", pstr));

  if (4 == sscanf (pstr, "%ld.%ld.%ld.%ld", &lIpA, &lIpB, &lIpC, &lIpD))
  {
    if (0x00 <= lIpA && 0xff >= lIpA &&
        0x00 <= lIpB && 0xff >= lIpB &&
        0x00 <= lIpC && 0xff >= lIpC &&
        0x00 <= lIpD && 0xff >= lIpD)
    {
      bSuccess = TRUE;
    }
  }
   TRACE(("End validate Interface Parm: %s. %s",
   pstr, bSuccess ? "SUCCESS" : "ERROR"));

  return bSuccess;
}

/*
** =======================================================================================
** =======================================================================================
*/
static BooleanT GetBcastAddr (char *pstrIp, char *pstrMask, char *pstrBcast)
{
  BooleanT  bSuccess = FALSE;
  long      lIpA     = 0;
  long      lIpB     = 0;
  long      lIpC     = 0;
  long      lIpD     = 0;

   TRACE(("Get Bcast for IP: %s  NetMask: %s", pstrIp, pstrMask));

  if (4 != sscanf (pstrIp, "%ld.%ld.%ld.%ld", &lIpA, &lIpB, &lIpC, &lIpD))
  {
    TRACE(("ERROR: Failed to sscanf to convert IP to Bcast"));
  }
  else
  {
    long  lIp = (lIpA << 24) | (lIpB << 16) | (lIpC << 8) | (lIpD);

    if (4 != sscanf (pstrMask, "%ld.%ld.%ld.%ld", &lIpA, &lIpB, &lIpC, &lIpD))
    {
      TRACE(("ERROR: Failed to sscanf to convert NetMask to Bcast"));
    }
    else
    {
      long  lMask   = (lIpA << 24) | (lIpB << 16) | (lIpC << 8) | (lIpD);
      long  lBcast  = ~lMask | lIp;

      sprintf (pstrBcast,"%ld.%ld.%ld.%ld",
              ((lBcast >> 24) & 0xff),
              ((lBcast >> 16) & 0xff),
              ((lBcast >> 8)  & 0xff),
              (lBcast & 0xff));

      bSuccess = TRUE;
    }
  }
   TRACE(("End get Bcast for IP: %s  NetMask: %s. %s",
   pstrIp, pstrMask, bSuccess ? "SUCCESS" : "ERROR"));

  return bSuccess;
}

/*
** =======================================================================================
** =======================================================================================
*/
static long CfgGetNegotiationTime ()
{
  long  lRC = 1;
  int   lFd = open ("/bin/drnic.cfg", O_RDONLY);
  char  strBuf[16];

  memset (strBuf, 0, sizeof (strBuf));

  if (-1 != lFd && -1 != read (lFd, strBuf, sizeof (strBuf)))
  {
    lRC = atoi (strBuf);
    close (lFd);
  }
  TRACE(("CfgGetNegotiationTime: %ld", lRC));

  return lRC;
}


void ValidateAndConfigIf (char *pstrIf, char **ppstrParms, long lNumIf)
{
   char strMsg[128] = {0};

   if (TRUE != ValidateIfParm (ppstrParms[0]))
   {
      sprintf(strMsg,"ERROR: Invalid input IP Address: %s", ppstrParms[0]);
      DisplayMsg (strMsg);
   }
   else if (TRUE != ValidateIfParm (ppstrParms[1]))
   {
      sprintf(strMsg,"ERROR: Invalid input NetMask: %s", ppstrParms[1]);
      DisplayMsg (strMsg);
   }
   else if (0 < strlen (ppstrParms[2]) && TRUE != ValidateIfParm (ppstrParms[2]))
   {
      sprintf(strMsg,"ERROR: Invalid input GateWay: %s", ppstrParms[2]);
      DisplayMsg (strMsg);
   }
   else if (NULL == pstrIf && TRUE != ValidateIfParm (ppstrParms[3]))
   {
      sprintf(strMsg,"ERROR: Invalid input Server IP: %s", ppstrParms[3]);
      DisplayMsg (strMsg);
   }
   else if (NULL == pstrIf)
   {
      BooleanT bSuccess          = FALSE;
      char        strConfig[128]    = {0};
      char        strMsg[128]       = {0};
      char        strBcast[32]      = {0};
      int            i;
      int            j;

      TRACE(("Entering Config Auto for all NIC interfaces"));

      memset (strBcast, 0, sizeof (strBcast));
      GetBcastAddr (ppstrParms[0], ppstrParms[1], strBcast);

      for (i=0; i<lNumIf && FALSE == bSuccess; i++)
      {
         memset (strConfig, 0, sizeof (strConfig));
         (0 != strBcast[0]) ?
         sprintf(strConfig,"eth  %s netmask %s broadcast %s down",ppstrParms[0],ppstrParms[1],strBcast) :
         sprintf(strConfig,"eth  %s netmask %s down",ppstrParms[0],ppstrParms[1]);

         for (j=0; j<lNumIf; j++)
         {
            strConfig[3] = 0x30 + j;
            TRACE(("Bring NIC Interface: eth%c (down)", 0x30 + j));

            if (TRUE != DrIfcfg (strConfig))
            {
               TRACE(("ERROR: Failed to bring NIC Interface: eth%c (down)", 0x30 + j));
            }
         }
         memset (strConfig, 0, sizeof (strConfig));
         (0 != strBcast[0]) ?
         sprintf(strConfig,"eth  %s netmask %s broadcast %s up",ppstrParms[0],ppstrParms[1],strBcast) :
         sprintf(strConfig,"eth  %s netmask %s up",ppstrParms[0],ppstrParms[1]);

         strConfig[3] = 0x30 + i;
         TRACE(("Bring NIC Interface: eth%c (up)", 0x30 + i));

         if (TRUE != DrIfcfg (strConfig))
         {
            TRACE(("ERROR: Failed to bring NIC Interface: eth%c (up)", 0x30 + i));
         }
         else
         {
            if (0 < strlen (ppstrParms[2]))
            {
               memset (strConfig, 0, sizeof (strConfig));
               sprintf(strConfig, "add default gw %s", ppstrParms[2]);

               TRACE(("Add Default Gateway for without specific Dev: %s", ppstrParms[2]));

               /* Attempt to remove any previous default gateways from the route table*/
               DrIfRoute("del default");
               if (TRUE != DrIfRoute (strConfig))
               {
                  TRACE(("ERROR: Failed to Add Default Gateway: %s", ppstrParms[2]));
               }
               else
               {
                  TRACE(("Add Default Gateway successfully: %s", ppstrParms[2]));
               }
            }

            sprintf(strMsg,"Contact Server: %s using Interface: eth%c. Please Wait...",
            ppstrParms[3], 0x30 + i);

            //DisplayInfo (strMsg);

            sleep (CfgGetNegotiationTime ());

            if (TRUE == DrPg (ppstrParms[3]))
            {
               sprintf(strMsg,"Contact Server: %s Successfully using Interface: eth%c",
               ppstrParms[3], 0x30 + i);
               TRACE((strMsg));
               bSuccess = TRUE;
            }
            else
            {
               TRACE(("WARN: Failed to contact Server: %s Using Interface: eth%c",
               ppstrParms[3], 0x30 + i));
            }
         }
      }
      if (TRUE == bSuccess)
      {
         DisplayMsg (strMsg);
      }
      else
      {
         sprintf(strMsg,"ERROR: Failed contact Server: %s using all interfaces",ppstrParms[3]);
         DisplayMsg (strMsg);
      }
   }
   else if (NULL != pstrIf)
   {
      char  strConfig[128]    = {0};
      char  strBcast[32]      = {0};

      memset (strConfig, 0, sizeof (strConfig));
      memset (strBcast,  0, sizeof (strBcast));

      if (TRUE == GetBcastAddr (ppstrParms[0], ppstrParms[1], strBcast))
      {
         sprintf(strConfig, "%s %s netmask %s broadcast %s up",
         pstrIf, ppstrParms[0], ppstrParms[1], strBcast);
      }
      else
      {
         sprintf(strConfig, "%s %s netmask %s up",
         pstrIf, ppstrParms[0], ppstrParms[1]);
      }

      if (TRUE != DrIfcfg (strConfig))
      {
         sprintf(strMsg,"ERROR: Failed to config Interface: %s", pstrIf);
         DisplayMsg (strMsg);
      }
      else
      {
         sprintf(strMsg,"Config Interface: %s successfully", pstrIf);
         DisplayMsg (strMsg);
      }

      if (0 < strlen (ppstrParms[2]))
      {
         /* Attempt to remove any previous default gateways from the route table*/
         memset (strConfig, 0, sizeof (strConfig));
         sprintf(strConfig, "del default dev %s", pstrIf);
         DrIfRoute(strConfig);

         memset (strConfig, 0, sizeof (strConfig));
         sprintf(strConfig, "add default gw %s dev %s", ppstrParms[2], pstrIf);

         if (TRUE != DrIfRoute (strConfig))
         {
            sprintf(strMsg,"ERROR: Failed to Add Default Gateway: %s", ppstrParms[2]);
            DisplayMsg (strMsg);
         }
         else
         {
            sprintf(strMsg,"Add Default Gateway successfully: %s", ppstrParms[2]);
            DisplayMsg (strMsg);
         }
      }
   }
}

/*
** =======================================================================================
** =======================================================================================
*/
long GetNicInterfaces ()
{
   long  lInt  = 0;
   FILE  *pFd  = fopen ("/proc/net/dev", "r");

   TRACE(("Get all NIC interfaces from file: /proc/net/dev"));

   if (NULL == pFd)
   {
      TRACE(("ERROR: Failed to open file /proc/net/dev. %s", strerror(errno)));
   }
   else
   {
      char  strBuf[256] = {0};
      char  *pstr = NULL;

      while (NULL != fgets (strBuf, sizeof (strBuf), pFd))
      {
         pstr = (char *) strtok (strBuf, " ");

         if (NULL != pstr && NULL != strstr (pstr, "eth"))
         {
            TRACE(("Got NIC interface: eth%ld", lInt));
            lInt++;
         }
      }
      fclose (pFd);
   }
   TRACE(("Found (%ld) NIC interfaces from /proc/net/dev. %s",
   lInt, (lInt > 0) ? "SUCCESS" : "ERROR"));

   return lInt;
}

