static const char nvBBtrace_c[] = "$Header:";

/* $Header: /faststuff/CVS/dastuff190503/vaultos/unix/linux/gui/src/nvBBtrace.c,v 1.1 2007/03/02 07:23:14 sapan Exp $ */

#include <errno.h>
#include <stdio.h>
#include "thincore/sys.h"

static FILE *gTraceIO = NULL;
static long  glLevel = ALWAYS;

/*
** ============================================================================
** ============================================================================
*/
extern void NvTraceToFile
(
	const char *pstrFile
)
{
	if(NULL != gTraceIO && stderr != gTraceIO)
	{
		fclose(gTraceIO);
	}
	if (NULL == pstrFile)
	{
		gTraceIO = stderr;
	}
	else
	{
		int iFd = open(pstrFile, O_WRONLY | O_CREAT | O_TRUNC, 0666);

		if (0 <= iFd)
		{
			FILE *pTrace = fdopen(iFd, "w");

			if(NULL != pTrace)
			{
				gTraceIO = pTrace;
			}
			else
			{
				close(iFd);
				fprintf(stderr, " Failed open trace file. %d %s\n",
						errno,
						strerror(errno));
				gTraceIO = stderr;
			}
		}
	}
}

extern long NvTraceSetLevel
(
	long lLevel
)
{
	long lResult = glLevel;
	
	glLevel = lLevel;
	return lResult;
}


extern void NvTrace
(
        const char* pstrMod,
        long         lId,
        long         lCode,
        long         lLevel,
        const char *pstrFormat,
        va_list args
)
{
        /*va_list       args;*/

        if(NULL != gTraceIO && glLevel >= lLevel)
        {
                struct timeval sTime;

                gettimeofday(&sTime, NULL);

                fprintf(gTraceIO, "%ld:%ld.%03ld ",
                                                (long)getpid(),
                                                (long)(sTime.tv_sec % 1000),
                                                (long)(sTime.tv_usec / 1000));
                /*va_start(args, pstrFormat);*/
                vfprintf(gTraceIO, pstrFormat, args);
                /*va_end(args);*/
                fprintf(gTraceIO, "\n");
                fflush(gTraceIO);
        }
}

extern void TraceMessageInline
(
    long           lTraceId,
    long           lStatusCode,
    long    eLevel,
    const char    *pstrFormat,
    ... /* varargs */
)
{
     static const char *pstrModuleId = "NVAIXDR";
     va_list            args;
           va_start(args, pstrFormat);
           NvTrace(pstrModuleId, lTraceId, lStatusCode, eLevel, pstrFormat, args);
           va_end(args);
}





