#!/bin/sh

#
# VaultDR Client startup script.
#

WARN="FALSE"
PORT=""
USAGE="Usage: VaultDr_client.sh [OPTION]
		\n\nOptions:\
		\n  -h\t\t Show this message \
		\n  -p <port>\t Invoke drdaemon with Inbound Port option"

failure ()
{
echo "Error : $1"
echo "Exiting ..."
exit 1
}

warning ()
{
echo "Warning : $1"
WARN="TRUE"
}

# Parse arguments
while getopts hp: OPT
do case "$OPT" in
	h) echo $USAGE
	   exit 0
		;;
	
	p) PORT="$OPTARG"
		;;

	\?) echo $USAGE >&2
	 	 exit 1
		 ;;
	esac
done

shift `expr $OPTIND - 1`

# Check OS , Kernel Version and User.
uname -o | grep -i "Linux" > /dev/null 2>&1 || warning "Operating System is not Linux"
uname -r | grep "2.6" > /dev/null 2>&1 || warning "This program should be run on Linux kernel 2.6"
whoami | grep -i "root" > /dev/null 2>&1 || failure "Please run this program as root user"

if [ ! -d /trace ]; then
mkdir /trace || failure "Failed to create the /trace directory"
fi

# Try to run udevstart /  udevsettle/udevtrigger to detect all devices.
# This might not be absolutely necessary as the live CD should take care of devices

if [ ! -f /sbin/udevstart -a ! -f /sbin/udevtrigger ]; then
warning "Could not find /sbin/udevstart or /sbin/udevtrigger"
else
	if [ -f /sbin/udevstart ]; then
		if [ ! -f /bin/udevstart ]; then
			ln -s /sbin/udevstart /bin/udevstart	
		fi

	elif [ -f /sbin/udevtrigger ]; then
	
		# Adding udevstart script as drdaemon will need it.
		echo "/sbin/udevtrigger > /dev/null 2>&1" >> /bin/udevstart
		echo "/sbin/udevsettle > /dev/null 2>&1" >> /bin/udevstart
		chmod 0777 /bin/udevstart > /dev/null 2>&1
	fi
/bin/udevstart > /dev/null 2>&1
fi

if [ $WARN = "TRUE" ]; then
echo ""
echo "Press any key to conintue ..."
read ans
fi

cp drdaemon /bin/ > /dev/null 2>&1 || failure "Failed to copy drdaemon to /bin/"
chmod 0777 /bin/drdaemon > /dev/null 2>&1

if [ -n $PORT ]; then
	drdaemon -p $PORT
else
	drdaemon
fi
