#!/bin/sh

#
# Script to install Netvault Server and VaultDR Server
# Logs to /var/log/nvinstall.log
#

NV_PARA="/root/nv_parameters"
NV_DIST="/root/netvault*Linux*.tar.gz"
DRC_NPK="/root/drc*.npk"
NV_LICENSE_FILE="/root/nvlicense.dat"
DRC_LICENSE_FILE="/root/drc_14day.dat"

echo "Installing Netvault ..."
exec > /var/log/nvinstall.log
exec 2>&1

echo "Installing Netvault ..."
tar -zxf $NV_DIST -C /root/  || exit 1
cd /root/netvault/ || exit 1
./install ../nv_parameters || exit 1
cd -

echo "Installing VaultDR Server ..."
/usr/netvault/bin/installplugin $DRC_NPK || exit 1

echo "Adding VaultDR Client ..."
echo "[self]" >> /usr/netvault/config/dr.cfg
echo "Addresses=127.0.0.1" >> /usr/netvault/config/dr.cfg
echo "Account=none" >> /usr/netvault/config/dr.cfg
echo "Port=10000" >> /usr/netvault/config/dr.cfg

echo "Installing new license ..."
/usr/netvault/bin/licenseinstall $NV_LICENSE_FILE
/usr/netvault/bin/licenseinstall $DRC_LICENSE_FILE

rm -fr /root/netvault $NV_DIST $DRC_NPK $NV_PARA  $NV_LICENSE_FILE $DRC_LICENSE_FILE


# This is a wrapper script , sometimes needed to overcome gdm issues for auto startup
echo "/usr/bin/gnome-terminal -x sudo /usr/netvault/bin/nvgui" > /usr/netvault/bin/nvgui_start
chmod 0777 /usr/netvault/bin/nvgui_start

exit 0
