#!/bin/sh

#
# This is a script to create a USB VaultDR image which just has the drdaemon and a startup script
# Usage : vaultOS_usb_create.sh device_name 
#

DEVICE=$1
MNT_DIR=usb_mnt

# ==================================================================================
# ==================================================================================
fn_umount_device ()
{
   /bin/umount /media/usbdisk1 2> /dev/null
   /bin/umount /media/usbdisk2 2> /dev/null
   /bin/umount /media/usbdisk  2> /dev/null
   /bin/umount ${DEVICE}1     2> /dev/null
   /bin/umount ${DEVICE}2     2> /dev/null
   /bin/umount $DEVICE      2> /dev/null
}


# ==================================================================================
# ==================================================================================
fn_make_partition ()
{
   /sbin/sfdisk $1 << EOF
,8
;
EOF
}


# ==================================================================================
# ==================================================================================
fn_delete_partition ()
{
   /sbin/sfdisk $1 << EOF
0,0
0,0
0,0
0,0
EOF
}  

export PATH=$PATH:/sbin/

if [ $# != 1 ]; then
failure "Usage : vaultOS_usb_create /dev/usb_device"
fi

if [ ! -d $MNT_DIR ]; then
mkdir $MNT_DIR
fi

# Prepare the USB Device
fn_umount_device 
fn_delete_partition $DEVICE
fn_umount_device
fn_make_partition $DEVICE
#/sbin/mkdosfs ${DEVICE}2
fn_umount_device
/sbin/mkfs -t ext2 ${DEVICE}1 || failure "Failed to make partitions"
mount -t ext2 ${DEVICE}1 $MNT_DIR || failure "Failed to mount usb partition"
rm -fr ${MNT_DIR}/lost+found

# copy the scripts

cp ${NV_BUILD_DIR}/vaultos/unix/linux/drdaemon  ${MNT_DIR}/ || failure "Failed to copy drdaemon to usb"
cp VaultDr_client.sh ${MNT_DIR}/ || failure "Failed to copy VaultDr_client.sh to usb"
chmod 0777 ${MNT_DIR}/VaultDr_client.sh ${MNT_DIR}/drdaemon || failure "Failed to change permissions of binaries on usb"

sync
sync

umount $MNT_DIR

echo "USB Created successfully"
echo "Saving USB Image on Disk.."
dd of=$PWD/x86dr_v5.0_usb.img if=$DEVICE  bs=1024  count=10240 conv=noerror,sync
if [ $? -eq 0 ]
then
   echo "USB Image Saved successfully"
else
   echo "ERROR: Saving USB Image to Disk Failed."
   exit 1
fi

rm -fr $MNT_DIR

exit 0
