align 4
__bcopy_start:

bcopy_gdt:	
		dw bcopy_gdt_size-1

.adj1:		
		dd bcopy_gdt
		dw 0
		dd 0000ffffh		
		dd 00009b00h		
		dd 0000ffffh		
		dd 008f9300h		
		dd 0000ffffh		
		dd 00009300h		
		dd 0000ffffh		
		dd 00cf9b00h		
		dd 0000ffffh		
		dd 00cf9300h		


bcopy_gdt_size:	equ $-bcopy_gdt

bcopy:		
		push eax
		pushf			
		push gs
		push fs
		push ds
		push es
		mov [cs:SavedSSSP],sp
		mov [cs:SavedSSSP+2],ss
		cli
		call enable_a20

.adj2:		
		o32 lgdt [cs:bcopy_gdt]
		mov eax,cr0
		or al,1
		mov cr0,eax		


.adj3a:		
		jmp 08h:.in_pm

.in_pm:		
		mov ax,10h		
		mov es,ax
		mov ds,ax
		mov al,18h		
		mov ss,ax
		mov fs,ax
		mov gs,ax	
		mov al,cl		
		shr ecx,2		
		a32 rep movsd		
		mov cl,al		
		and cl,3
		a32 rep movsb
		mov al,18h		
		mov es,ax
		mov ds,ax
		mov eax,cr0
		and al,~1
		mov cr0,eax		


.adj3b:		
		jmp 0:.in_rm

.in_rm:		
		lss sp,[cs:SavedSSSP]
		pop es
		pop ds
		pop fs
		pop gs
		call disable_a20
		popf			
		pop eax
		ret

%define	io_delay	call _io_delay
%define IO_DELAY_PORT	80h		
%define disable_wait 	32		

%define A20_DUNNO	0		
%define A20_NONE	1		
%define A20_BIOS	2		
%define A20_KBC		3		
%define A20_FAST	4		

align 2
A20List					dw a20_dunno, a20_none, a20_bios, a20_kbc, a20_fast
A20DList				dw a20d_dunno, a20d_none, a20d_bios, a20d_kbc, a20d_fast
a20_adjust_cnt	equ ($-A20List)/2

slow_out:	
		out dx, al		

_io_delay:	
		out IO_DELAY_PORT,al
		out IO_DELAY_PORT,al
		ret

enable_a20:
		pushad
		mov byte [cs:A20Tries],255 

try_enable_a20:
%if DO_WBINVD
		call try_wbinvd
%endif
		mov bp,[cs:A20Type]
		add bp,bp			


.adj4:		
		jmp word [cs:bp+A20List]

a20_dunno:
a20_none:
		mov byte [cs:A20Type], A20_NONE
		call a20_test
		jnz a20_done

a20_bios:
		mov byte [cs:A20Type], A20_BIOS
		mov ax,2401h
		pushf				
		int 15h
		popf
		call a20_test
		jnz a20_done

a20_kbc:
		mov dl, 1			
		call empty_8042
		jnz a20_done			
		mov byte [cs:A20Type], A20_KBC	
		mov al,0D1h			
		out 064h, al
		call empty_8042_uncond
		mov al,0DFh			
		out 060h, al
		call empty_8042_uncond

.kbc_wait:	
		push cx
		xor cx,cx


.kbc_wait_loop:
		call a20_test
		jnz a20_done_pop
		loop .kbc_wait_loop
		pop cx


a20_fast:
		mov byte [cs:A20Type], A20_FAST	
		in al, 092h
		or al,02h
		and al,~01h			
		out 092h, al

.fast_wait:	
		push cx
		xor cx,cx


.fast_wait_loop:
		call a20_test
		jnz a20_done_pop
		loop .fast_wait_loop
		pop cx
		dec byte [cs:A20Tries]
		jnz try_enable_a20
		mov si, err_a20
		jmp abort_load


a20_done_pop:	
		pop cx

a20_done:	
		popad
		ret

a20_test:
		push es
		push cx
		push ax
		mov cx,0FFFFh		
		mov es,cx
		mov cx,32		
		mov ax,[cs:A20Test]


.a20_wait:	
		inc ax
		mov [cs:A20Test],ax
		io_delay		
		cmp ax,[es:A20Test+10h]
		loopz .a20_wait

.a20_done:	
		pop ax
		pop cx
		pop es
		ret

disable_a20:
		pushad
%if DO_WBINVD
		call try_wbinvd
%endif
		mov bp,[cs:A20Type]
		add bp,bp			

.adj5:		
		jmp word [cs:bp+A20DList]

a20d_bios:
		mov ax,2400h
		pushf				
		int 15h
		popf
		jmp short a20d_snooze

a20d_fast:
		in al, 092h
		and al,~03h
		out 092h, al
		jmp short a20d_snooze

a20d_kbc:
		call empty_8042_uncond
		mov al,0D1h
		out 064h, al		
		call empty_8042_uncond
		mov al,0DDh		
		out 060h, al
		call empty_8042_uncond
		
a20d_snooze:
		push cx
		mov cx, disable_wait

.delayloop:	
		call a20_test
		jz .disabled
		loop .delayloop

.disabled:	
		pop cx
a20d_dunno:
a20d_none:
		popad
		ret

empty_8042_uncond:
		xor dl,dl

empty_8042:
		call a20_test
		jz .a20_on
		and dl,dl
		jnz .done

.a20_on:	
		io_delay
		in al, 064h		
		test al,1
		jz .no_output
		io_delay
		in al, 060h	
		jmp short empty_8042

.no_output:
		test al,2
		jnz empty_8042
		io_delay

.done:		
		ret	

%if DO_WBINVD
try_wbinvd:
		wbinvd
		ret
%endif

%define ADJUST	(__bcopy_start - trackbuf)

		align 2
adjlist		dw bcopy_gdt.adj1 - ADJUST
		dw bcopy.adj2 + 5 - ADJUST
		dw bcopy.adj3a + 1 - ADJUST
		dw bcopy.adj3b + 1 - ADJUST
		dw try_enable_a20.adj4 + 3 - ADJUST
		dw disable_a20.adj5 + 3 - ADJUST
adjlist_cnt	equ ($-adjlist)/2

bcopy_over_self:
		push esi	
		push edi
		push ecx
		xor bx,bx
		mov es,bx
		mov ds,bx
		mov si,__bcopy_start
		mov di,trackbuf
		mov cx,(__bcopy_end - __bcopy_start + 3) >> 2
		rep movsd
		mov si,A20List - ADJUST
		mov cx,a20_adjust_cnt


.adjust1:
		sub word [si], ADJUST
		inc si
		inc si
		loop .adjust1
		mov si, adjlist
		mov cx, adjlist_cnt


.adjust2:
		lodsw
		xchg di,ax
		sub word [di], ADJUST
		loop .adjust2
		jmp .next-ADJUST


.next:
		pop ecx
		pop edi
		pop esi
		call bcopy
		pop gs
		pop fs
		pop es
		pop ds
		popfd
		popad
		jmp 0:7c00h

__bcopy_end:
