open:
		call searchdir
		jz open_return

openfd:
		pushf
		mov [FBytes1],ax
		mov [FBytes2],dx
		add ax,[ClustSize]
		adc dx,byte 0
		sub ax,byte 1
		sbb dx,byte 0
		div word [ClustSize]
		mov [FClust],ax		
		mov [FNextClust],si	
		mov ax,[EndOfGetCBuf]	
		mov [FPtr],ax		
		popf			

open_return:	
		ret

getc:
		stc			
		mov ecx,[FBytes]
		jecxz getc_ret
		mov si,[FPtr]
		cmp si,[EndOfGetCBuf]
		jb getc_loaded
		mov cx,[FClust]
		cmp cx,[BufSafe]
		jna getc_oksize
		mov cx,[BufSafe]

getc_oksize:	
		sub [FClust],cx		
		mov si,[FNextClust]
		push es			
		push ds
		pop es
		mov bx,getcbuf
		push bx
		call getfssec		
		mov [FNextClust],si	
		pop si			
		pop es			

getc_loaded:	
		lodsb			
		mov [FPtr],si		
		dec dword [FBytes]	
		clc			

getc_ret:	
		ret

ungetc:
		mov si,[FPtr]
		dec si
		mov [si],al
		mov [FPtr],si
		inc dword [FBytes]
		ret

skipspace:
skipspace_loop: 
		call getc
		jc skipspace_eof
		cmp al,1Ah			
		je skipspace_eof
		cmp al,0Ah
		je skipspace_eoln
		cmp al,' '
		jbe skipspace_loop
		ret				

skipspace_eof:	
		cmp al,al			
		stc				
		ret

skipspace_eoln: 
		add al,0FFh			
		ret

getint:
		mov di,NumBuf

gi_getnum:	
		cmp di,NumBufEnd	
		jae gi_loaded
		push di
		call getc
		pop di
		jc gi_loaded
		stosb
		cmp al,'-'
		jnb gi_getnum
		call ungetc		

gi_loaded:	
		mov byte [di],0
		mov si,NumBuf

parseint:
		push eax
		push ecx
		push bp
		xor eax,eax		
		mov ebx,eax		
		mov ecx,ebx		
		xor bp,bp               

pi_begin:	
		lodsb
		cmp al,'-'
		jne pi_not_minus
		xor bp,1		
		jmp short pi_begin

pi_not_minus:
		cmp al,'0'
		jb pi_err
		je pi_octhex
		cmp al,'9'
		ja pi_err
		mov cl,10		
		jmp short pi_foundbase

pi_octhex:
		lodsb
		cmp al,'0'
		jb pi_km		
		or al,20h		
		cmp al,'x'
		je pi_ishex
		cmp al,'7'
		ja pi_err
		mov cl,8		
		jmp short pi_foundbase

pi_ishex:
		mov al,'0'		
		mov cl,16		

pi_foundbase:
		call unhexchar
		jc pi_km                
		cmp al,cl
		jae pi_km		
		imul ebx,ecx		
		add ebx,eax             
		lodsb
		jmp short pi_foundbase

pi_km:
		dec si			
		lodsb
		or al,20h
		cmp al,'k'
		je pi_isk
		cmp al,'m'
		je pi_ism
		dec si			

pi_fini:	
		and bp,bp
		jz pi_ret		
		neg ebx			

pi_done:	
		clc

pi_ret:		
		pop bp
		pop ecx
		pop eax
		ret

pi_err:		
		stc
		jmp short pi_ret

pi_isk:		
		shl ebx,10		
		jmp short pi_done

pi_ism:		
		shl ebx,20		
		jmp short pi_done

unhexchar:
		cmp al,'0'
		jb uxc_ret		
		cmp al,'9'
		ja uxc_1
		sub al,'0'		
		ret

uxc_1:          
		or al,20h		
		cmp al,'a'
		jb uxc_ret		
		cmp al,'f'
		ja uxc_err
		sub al,'a'-10           
		ret

uxc_err:
		stc

uxc_ret:	
		ret

getline:
		call skipspace
		mov dl,1                
		jz gl_eof               
		jc gl_eoln              
		call ungetc

gl_fillloop:	
		push dx
		push di
		call getc
		pop di
		pop dx
		jc gl_ret		
		cmp al,' '
		jna gl_ctrl
		xor dx,dx

gl_store:	
		stosb
		jmp short gl_fillloop

gl_ctrl:	
		cmp al,10
		je gl_ret		
		cmp al,26
		je gl_eof
		and dl,dl
		jnz gl_fillloop		
		mov al,' '		
		inc dx
		jmp short gl_store

gl_eoln:        
		clc                     
		jmp short gl_ret

gl_eof:         
		stc

gl_ret:		
		pushf			
		and dl,dl
		jnz gl_xret
		mov al,' '
		stosb

gl_xret:	
		popf
		ret


