%define IS_ISOLINUX 1

%ifndef _MACROS_INC
%define _MACROS_INC

%ifndef IS_SYSLINUX
%define IS_SYSLINUX 0
%endif
%ifndef IS_MDSLINUX
%define IS_MDSLINUX 0
%endif
%ifndef IS_PXELINUX
%define IS_PXELINUX 0
%endif
%ifndef IS_ISOLINUX
%define IS_ISOLINUX 0
%endif

%macro	zb	1.nolist
	times %1 db 0
%endmacro
%macro	zw	1.nolist
	times %1 dw 0
%endmacro
%macro	zd	1.nolist
	times %1 dd 0
%endmacro

%macro asciidec	1.nolist
%endmacro

%endif

%ifndef _CONFIG_INC
%define _CONFIG_INC

max_cmd_len			equ 255
HIGHMEM_MAX			equ 037FFFFFFh
DEFAULT_BAUD		equ 9600
BAUD_DIVISOR		equ 115200

%assign	DO_WBINVD 0	

%ifndef DEPEND
%define VERSION "2.06"
%define VER_MAJOR 2
%define VER_MINOR 6
%endif

%define	version_str	VERSION
%define date		DATE_STR
%define	year		'2003'

%endif

%ifndef _KERNEL_INC
%define _KERNEL_INC

struc real_mode_seg_t
resb 20h-($-$$)
kern_cmd_magic	resw 1
kern_cmd_offset resw 1
resb 497-($-$$)
bs_setupsecs	resb 1
bs_rootflags	resw 1
bs_syssize	resw 1
bs_swapdev	resw 1
bs_ramsize	resw 1
bs_vidmode	resw 1
bs_rootdev	resw 1
bs_bootsign	resw 1
su_jump		resb 1
su_jump2	resb 1
su_header	resd 1
su_version	resw 1
su_switch	resw 1
su_setupseg	resw 1
su_startsys	resw 1
su_kver		resw 1
su_loader	resb 1
su_loadflags	resb 1
su_movesize	resw 1
su_code32start	resd 1
su_ramdiskat	resd 1
su_ramdisklen	equ $
su_ramdisklen1	resw 1
su_ramdisklen2	resw 1
su_bsklugeoffs	resw 1
su_bsklugeseg	resw 1
su_heapend	resw 1
su_pad1		resw 1
su_cmd_line_ptr	resd 1
su_ramdisk_max	resd 1
resb (9000h-12)-($-$$)
linux_stack	equ $
linux_fdctab	equ $
resb 9000h-($-$$)
cmd_line_here	equ $
endstruc

CMD_MAGIC	equ 0A33Fh
HEADER_ID       equ 'HdrS'
LOAD_HIGH	equ 01h	
CAN_USE_HEAP    equ 80h
syslinux_id	equ 031h
pxelinux_id	equ 032h
isolinux_id	equ 033h
%endif


%ifndef _BIOS_INC
%define _BIOS_INC

absolute 4*1Eh
fdctab		equ $
fdctab1		resw 1
fdctab2		resw 1

absolute 0400h
serial_base	resw 4
absolute 0413h
BIOS_fbm	resw 1
absolute 046Ch
BIOS_timer	resw 1
absolute 0472h
BIOS_magic	resw 1
absolute 0484h
BIOS_vidrows    resb 1
%endif


%ifndef _TRACERS_INC
%define _TRACERS_INC
%ifdef DEBUG_TRACERS
%macro TRACER 1
  call debug_tracer
	db %1
%endmacro
%else 
%macro  TRACER  1
%endmacro
%endif  
%endif 


my_id									equ isolinux_id
FILENAME_MAX_LG2 			equ 8
FILENAME_MAX					equ (1 << FILENAME_MAX_LG2)
NULLFILE							equ 0
retry_count						equ 6
%assign HIGHMEM_SLOP 	128*1024
MAX_OPEN_LG2					equ 6
MAX_OPEN							equ (1 << MAX_OPEN_LG2)
SECTORSIZE_LG2				equ 11
SECTORSIZE						equ (1 << SECTORSIZE_LG2)

%define vk_power			6	
%define	max_vk				(1 << vk_power)
%define vk_shift			(16-vk_power)
%define vk_size				(1 << vk_shift)

struc vkernel
vk_vname:	resb FILENAME_MAX
vk_rname:	resb FILENAME_MAX
vk_appendlen:	resw 1
alignb 4
vk_append:	resb max_cmd_len+1
alignb 4
vk_end:		equ $
endstruc

%ifndef DEPEND
%if (vk_end > vk_size) || (vk_size*max_vk > 65536)
%error "Too many vkernels defined, reduce vk_power"
%endif
%endif

real_mode_seg			equ 3000h
vk_seg          	equ 2000h
xfer_buf_seg			equ 1000h
comboot_seg				equ real_mode_seg

struc open_file_t
file_sector	resd 1
file_left		resd 1
endstruc

%ifndef DEPEND
%if (open_file_t_size & (open_file_t_size-1))
%error "open_file_t is not a power of 2"
%endif
%endif

absolute 			1000h
trackbuf			resb 8192
trackbufsize	equ $-trackbuf
xbs_textbuf		equ 0
xbs_vgabuf		equ trackbufsize
xbs_vgatmpbuf	equ 2*trackbufsize

struc dir_t
dir_lba		resd 1
dir_len		resd 1
dir_clust	resd 1
endstruc

absolute 5000h
VKernelBuf:	resb vk_size
alignb 4
AppendBuf       resb max_cmd_len+1		
KbdMap					resb 256							
FKeyName				resb 10*FILENAME_MAX	
NumBuf					resb 15								
NumBufEnd				resb 1								
ISOFileName			resb 64								
ISOFileNameEnd	equ $
alignb 32
KernelName      resb FILENAME_MAX			
KernelCName     resb FILENAME_MAX			
InitRDCName     resb FILENAME_MAX			
MNameBuf				resb FILENAME_MAX
InitRD					resb FILENAME_MAX
PartInfo				resb 16			
E820Buf					resd 5			
HiLoadAddr      resd 1			
HighMemSize			resd 1			
RamdiskMax			resd 1			
KernelSize			resd 1			
SavedSSSP				resd 1			
PMESP						resd 1			
RootDir					resb dir_t_size		
CurDir					resb dir_t_size		
KernelClust			resd 1			
InitStack				resd 1			
FirstSecSum			resd 1			
ImageDwords			resd 1			
FBytes					equ $				
FBytes1					resw 1
FBytes2					resw 1
FClust					resw 1			
FNextClust			resw 1			
FPtr						resw 1			
CmdOptPtr       resw 1			
KernelCNameLen  resw 1			
InitRDCNameLen  resw 1			
NextCharJump    resw 1			
SetupSecs				resw 1			
A20Test					resw 1			
A20Type					resw 1			
CmdLineLen			resw 1			
GraphXSize			resw 1			
VGAPos					resw 1			
VGACluster			resw 1			
VGAFilePtr			resw 1			
Com32SysSP			resw 1			
ConfigFile			resw 1			
PktTimeout			resw 1			
KernelExtPtr		resw 1			
LocalBootType		resw 1			
ImageSectors		resw 1			
DiskSys					resw 1			
TextAttrBX      equ $
TextAttribute   resb 1			
TextPage        resb 1			
CursorDX        equ $
CursorCol       resb 1			
CursorRow       resb 1			
ScreenSize      equ $
VidCols         resb 1			
VidRows         resb 1			
BaudDivisor			resw 1			
FlowControl			equ $
FlowOutput			resb 1			
FlowInput				resb 1			
FlowIgnore			resb 1			
RetryCount      resb 1			
KbdFlags				resb 1			
LoadFlags				resb 1			
A20Tries				resb 1			
FuncFlag				resb 1			
DisplayMask			resb 1			
ISOFlags				resb 1			
DiskError				resb 1			
DriveNo					resb 1			
TextColorReg		resb 17			
VGAFileBuf			resb FILENAME_MAX	
VGAFileBufEnd		equ $
VGAFileMBuf			resb FILENAME_MAX

alignb open_file_t_size
Files		resb MAX_OPEN*open_file_t_size

section .text
org 7C00h
bootsec		equ $

_start:
		cli
		jmp 0:_start1
		times 8-($-$$) nop

bi_pvd:				dd 0xdeadbeef
bi_file:			dd 0xdeadbeef
bi_length:		dd 0xdeadbeef
bi_csum:			dd 0xdeadbeef
bi_reserved:	times 10 dd 0xdeadbeef

_start1:	
		mov [cs:InitStack],sp
		mov [cs:InitStack+2],ss
		xor ax,ax
		mov ss,ax
		mov sp,_start
		mov ds,ax
		mov es,ax
		mov fs,ax
		mov gs,ax
		sti
		cld
		mov si,strBakBone
		call writestr

initial_csum:	
		xor edi,edi
		mov si,_start1
		mov cx,(SECTORSIZE-64) >> 2

.loop:		
		lodsd
		add edi,eax
		loop .loop
		mov [FirstSecSum],edi
		mov eax,[bi_length]
		sub eax,SECTORSIZE-3
		shr eax,2
		mov [ImageDwords],eax
		add eax,(2047 >> 2)
		shr eax,9
		mov [ImageSectors],ax
		mov [DriveNo],dl
		mov ax,4B01h
		mov dl,[DriveNo]
		mov si,spec_packet
		int 13h
		jc spec_query_failed
		mov dl,[DriveNo]
		cmp [sp_drive],dl
		jne spec_query_failed

found_drive:
		mov eax,[bi_file]
		inc eax
		mov bx,((7C00h+2048) >> 4)
		mov es,bx
		xor bx,bx
		mov bp,[ImageSectors]
		call getlinsec
		push ds
		pop es

verify_image:
		mov si,7C00h+2048
		mov bx,es
		mov ecx,[ImageDwords]
		mov edi,[FirstSecSum]

.loop		es lodsd
		add edi,eax
		dec ecx
		jz .done
		and si,si
		jnz .loop
		add bx,1000h
		mov es,bx
		jmp short .loop

.done:		
		mov ax,ds
		mov es,ax
		cmp [bi_csum],edi
		je integrity_ok
		call writemsg
		jmp kaboom

integrity_ok:
		jmp all_read

spec_query_failed:
		call writemsg
		mov dl,0FFh

.test_loop:	
		pusha
		mov ax,4B01h
		mov si,spec_packet
		mov byte [si],13
		int 13h
		popa
		jc .still_broken
		mov al,dl
		call writehex2
		call crlf
		cmp byte [sp_drive],dl
		jne .maybe_broken
		mov [DriveNo],dl

.found_drive:	
		jmp found_drive

.maybe_broken:
		cmp byte [DriveNo],dl
		je .found_drive

.still_broken:	
		dec dx
		cmp dl, 80h
		jnb .test_loop
		mov dl,[DriveNo]
		cmp dl,81h
		jb fatal_error
		mov al,dl
		call writehex2
		call crlf
		jmp .found_drive

fatal_error:

.norge:		
		jmp short .norge

writemsg:	
		push ax
		push si
		pop si
		call writestr
		pop ax				
		ret

writechr:
		jmp near writechr_simple

writechr_simple:
		pushfd
		pushad
		mov ah,0Eh
		xor bx,bx
		int 10h
		popad
		popfd
		ret

getonesec:
		mov bp,1

getlinsec:
		mov si,dapa
		mov [si+4],bx
		mov bx,es
		mov [si+6],bx
		mov [si+8],eax

.loop:
		push bp
		cmp bp,[MaxTransfer]
		jbe .bp_ok
		mov bp,[MaxTransfer]

.bp_ok:
		mov [si+2],bp
		push si
		mov dl,[DriveNo]
		mov ah,42h
		call xint13
		pop si
		pop bp
		movzx eax,word [si+2]
		add [si+8],eax
		sub bp,ax
		shl ax,SECTORSIZE_LG2-4
		add [si+6],ax
		and bp,bp
		jnz .loop
		mov eax,[si+8]
		ret

xint13:		
		mov byte [RetryCount],retry_count

.try:		
		pushad
		int 13h
		jc .error
		add sp,byte 8*4
		ret

.error:
		mov [DiskError],ah
		popad
		mov [DiskSys],ax
		dec byte [RetryCount]
		jz .real_error
		push ax
		mov al,[RetryCount]
		mov ah,[dapa+2]
		cmp al,2
		ja .nodanger
		mov ah,1
		jmp short .setsize

.nodanger:
		cmp al,retry_count-2
		ja .again
		shr ah,1
		adc ah,0

.setsize:
		mov [MaxTransfer],ah
		mov [dapa+2],ah

.again:
		pop ax
		jmp .try

.real_error:	
		mov al,[DiskError]
		call writehex2
		mov ax,[DiskSys]
		call writehex4
		mov al,dl
		call writehex2
		call crlf

kaboom:
		lss sp,[cs:Stack]
		mov ax,cs
		mov ds,ax
		mov es,ax
		mov fs,ax
		mov gs,ax
		sti
		call getchar
		cli
		mov word [BIOS_magic],0
		jmp 0F000h:0FFF0h

crlf:
	mov si,crlf_msg

cwritestr:
    pushfd
		pushad

.top:
		lodsb
    and al,al
		jz .end
    call writechr
		jmp short .top

.end:
		popad
    popfd
		ret

writestr	equ cwritestr

writehex2:
    pushfd
    pushad
    rol eax,24
    mov cx,2
    jmp short writehex_common

writehex4:
    pushfd
    pushad
    rol eax,16
    mov cx,4
    jmp short writehex_common

writehex8:
    pushfd
    pushad
    mov cx,8

writehex_common:
.loop:    
		rol eax,4
    push eax
    and al,0Fh
    cmp al,10
    jae .high

.low:   
		add al,'0'
    jmp short .ischar

.high:    
		add al,'A'-10

.ischar:  
		call writechr
    pop eax
    loop .loop
    popad
    popfd
    ret


strBakBone	db	'VaultDR 3.406 (c) Copyright BakBone Software, Inc. 2000-2001',CR,LF,CR,LF, \
								'  VaultOS Disaster Recovery Client Boot Utility',CR,LF, \
								'  Copyright (c) BakBone Software, Inc. 2000-2001',CR,LF,CR,LF, \
								'  Copyright (c) 1989, 1991 Free Software Foundation, Inc.',CR,LF, \
								'  59 Temple Place, Suite 330, Boston, MA 02111-1307 USA. Everyone is',CR,LF, \
								'  permitted to copy and distribute verbatim copies of the enclosed',CR,LF, \
								'  GPL license document, but changing it is not allowed.',CR,LF,CR,LF, \
								'  VaultOS Warranty Disclaimer:',CR,LF, \
								'  1. Because the VaultOS program is an open source derivative, licensed',CR,LF, \
								'     free of charge, there is no warranty for the VaultOS program, to',CR,LF, \
								'     the extent permitted by applicable law. Except when otherwise stated',CR,LF, \
								'     in writing the copyright holders and/or other parties provide the',CR,LF, \
								'     program as is without warranty of any kind, either expressed or',CR,LF, \
								'     implied, including, but not limited to the implied warranties of',CR,LF, \
								'     merchantability and fitness for a particular purpose. The entire',CR,LF, \
								'     risk as to the quality and performance of the VaultOS program is with',CR,LF, \
								'     you. Should the VaultOS program prove defective, you assume the cost',CR,LF, \
								'     of all necessary servicing, repair or correction.',CR,LF,0

crlf_msg				db CR, LF
null_msg				db 0
align 8, 				db 0
spec_packet:		db 13h
sp_media:				db 0
sp_drive:				db 0
sp_controller:	db 0
sp_lba:					dd 0
sp_devspec:			dw 0
sp_buffer:			dw 0
sp_loadseg:			dw 0
sp_sectors:			dw 0
sp_chs:					db 0,0,0
sp_dummy:				db 0
align 8, 				db 0
dspec_packet:		db 13h
dsp_media:			db 0
dsp_drive:			db 0
dsp_controller:	db 0
dsp_lba:				dd 0
dsp_devspec:		dw 0
dsp_buffer:			dw 0
dsp_loadseg:		dw 0
dsp_sectors:		dw 1
dsp_chs:				db 0,0,0
dsp_dummy:			db 0

align 8, 				db 0
drive_params:		dw 30
dp_flags:				dw 0
dp_cyl:					dd 0
dp_head:				dd 0
dp_sec:					dd 0
dp_totalsec:		dd 0,0
dp_secsize:			dw 0
dp_dpte:				dd 0
dp_dpi_key:			dw 0
dp_dpi_len:			db 0
		db 0
		dw 0
dp_bus:					times 4 db 0
dp_interface:		times 8 db 0
db_i_path:			dd 0,0
db_d_path:			dd 0,0
		db 0
db_dpi_csum:		db 0

align 8, 				db 0
dapa:						dw 16
.count:					dw 0
.off:						dw 0
.seg:						dw 0
.lba:						dd 0
		dd 0
alignb 4, 			db 0
Stack						dw _start, 0
MaxTransfer			dw 32

rl_checkpt	equ $
rl_checkpt_off	equ ($-$$)
%ifndef DEPEND
%if rl_checkpt_off > 0x800
%error "Sector 0 overflow"
%endif
%endif

all_read:
		call adjust_screen
		mov al,NULLFILE
		mov di,FKeyName
		mov cx,10*(1 << FILENAME_MAX_LG2)
		rep stosb
		mov word [writechr+1], writechr_full-(writechr+3)
		TRACER 'T'
		TRACER '>'

check_escapes:
    mov ah,02h
    int 16h
    mov [KbdFlags],al
    test al,04h
    jnz skip_checks

dosram_k  equ (real_mode_seg+0x1000) >> 6
    int 12h
    cmp ax,dosram_k
    jae enough_ram
    mov si,err_noram
    call writestr
    jmp kaboom

enough_ram:
skip_checks:

%if DO_WBINVD
    pushfd
    pushfd
    pop eax
    mov ebx,eax
    xor eax,(1 << 18)
    push eax
    popfd
    pushfd
    pop eax
    popfd
    xor eax,ebx
    jnz is_486
    mov byte [try_wbinvd],0c3h

is_486:
%endif
    mov word [A20Type],0
		mov di,Files
		mov cx,(MAX_OPEN*open_file_t_size)/4
		xor eax,eax
		rep stosd
		mov si,linuxauto_cmd
		mov di,default_cmd
		mov cx,linuxauto_len
		rep movsb
		mov di,KbdMap
		xor al,al
		mov cx,256

mkkeymap:	
		stosb
		inc al
		loop mkkeymap

get_fs_structures:
		mov eax,[bi_pvd]
		mov bx,trackbuf
		call getonesec
		mov eax,[trackbuf+156+2]
		mov [RootDir+dir_lba],eax
		mov [CurDir+dir_lba],eax
		mov eax,[trackbuf+156+10]
		mov [RootDir+dir_len],eax		
		mov [CurDir+dir_len],eax
		add eax,SECTORSIZE-1
		shr eax,SECTORSIZE_LG2
		mov [RootDir+dir_clust],eax
		mov [CurDir+dir_clust],eax
		mov di,boot_dir
		mov al,02h
		call searchdir_iso
		jnz .found_dir
		mov di,isolinux_dir
		mov al,02h
		call searchdir_iso
		jz .no_isolinux_dir

.found_dir:
		mov [CurDir+dir_len],eax
		mov eax,[si+file_left]
		mov [CurDir+dir_clust],eax
		xor eax,eax
		xchg eax,[si+file_sector]
		mov [CurDir+dir_lba],eax

.no_isolinux_dir:
load_config:
		mov di,isolinux_cfg
		call open
		jz no_config_file

%include "ui.inc"
%include "runkernel.inc"
%include "comboot.inc"
%include "com32.inc"



is_bootsector:
%if IS_SYSLINUX || IS_MDSLINUX
    xor cx,cx
    jmp short load_bootsec
is_bss_sector:
    mov cx,superblock_len
load_bootsec:
    push cx
%endif
    xchg dx,ax
    shr eax,16
    xchg dx,ax    
    mov edi, 100000h
    call load_high
    call crlf
%if IS_SYSLINUX || IS_MDSLINUX
    pop cx
%endif
    sub edi,100000h
    push edi    

%if IS_SYSLINUX || IS_MDSLINUX
    jcxz .not_bss
    mov esi,superblock
    mov edi,100000h+(superblock-bootsec)
    movzx ecx,cx
    call bcopy

.not_bss:
%endif
    call vgaclearmode
    xor edx,edx
    xor eax,eax
%if IS_SYSLINUX || IS_MDSLINUX
    mov dl,[bsDriveNumber]
    mov si,PartInfo
    mov di,800h-18    
    push di
    mov cx,8    
    rep movsw
    pop si      
%elif IS_ISOLINUX
    mov dl,[DriveNo]
%elif IS_PXELINUX
    call reset_pxe
%endif

    pop ecx     
    cli
    xor ebx,ebx
    mov ds,bx
    mov es,bx
%if IS_PXELINUX
    lss sp,[InitStack]  
%else
    mov esp,7C00h
    pushad
    pushfd
    push bx
    push bx
    push bx
    push bx
%endif

    mov esi,100000h   
    mov edi,7C00h   
    jmp bcopy_over_self

%if IS_SYSLINUX || IS_MDSLINUX
%else
is_bss_sector:
    mov si,err_bssimage
    call cwritestr
    jmp enter_command
%endif


is_disk_image:
		TRACER CR
		TRACER LF
		TRACER 'D'
		TRACER ':'

		shl edx,16
		mov dx,ax
		mov di,img_table
		mov cx,img_table_count
		mov eax,[si+file_sector]
		mov [dsp_lba],eax
		mov byte [dsp_drive], 0

.search_table:
		TRACER 't'
		mov eax,[di+4]
		cmp edx,[di]
		je .type_found
		add di,8
		loop .search_table

.hard_disk_image:
		TRACER 'h'
		cmp edx,512
		jb .bad_image
		mov bx,trackbuf
		mov cx,1
		call getfssec
		cmp word [trackbuf+510],0aa55h
		jne .bad_image
		mov cx,4
		mov di,trackbuf+446
		xor ax,ax

.part_scan:
		cmp byte [di+4], 0
		jz .part_loop
		lea si,[di+1]
		call .hs_check
		add si,byte 4
		call .hs_check

.part_loop:
		add di,byte 16
		loop .part_scan
		push eax
		push edx
		mov bl,ah
		xor bh,bh
		inc bx
		xor ah,ah
		cwde
		mul bx
		shl eax,9
		pop ebx
		xor edx,edx
		div ebx
		and edx,edx
		jz .no_remainder
		inc eax

.no_remainder:	
		cmp eax,1024
		jna .ok_cyl
		mov ax,1024


.ok_cyl:	
		dec ax
		pop ebx
		shl ah,6
		or bl,ah
		xchg ax,bx
		shl eax,16
		mov ah,bl
		mov al,4
		mov byte [dsp_drive], 80h

.type_found:
		TRACER 'T'
		mov bl,[sp_media]
		and bl,0F0h
		or al,bl
		mov [dsp_media],al
		shr eax,8
		mov [dsp_chs],eax
		mov ax,[sp_devspec]
		mov [dsp_devspec],ax
		mov al,[sp_controller]
		mov [dsp_controller],al
		TRACER 'V'
		call vgaclearmode		
		mov ax,4C00h			
		mov si,dspec_packet
		mov dl,[DriveNo]
		lss sp,[InitStack]
		TRACER 'X'
		int 13h
		
.bad_image:
		mov si,err_disk_image
		call cwritestr
		jmp enter_command


.hs_check:
		mov bl,[si]			
		cmp bl,ah
		jna .done_track
		mov ah,bl			
.done_track:	mov bl,[si+1]
		and bl,3Fh			
		cmp bl,al
		jna .done_sector
		mov al,bl
.done_sector:	ret


local_boot:
		call vgaclearmode
		lss sp,[cs:Stack]		
		xor dx,dx
		mov ds,dx
		mov es,dx
		mov fs,dx
		mov gs,dx
		mov si,localboot_msg
		call writestr
		cmp ax,-1
		je .int18
		mov dl,al
		xor dh,dh
		push dx
		xor ax,ax			
		call xint13
		mov ax,0201h			
		mov cx,0001h			
		mov bx,trackbuf
		call xint13
		pop dx
		cli				
		mov si,trackbuf
		mov di,07C00h
		mov cx,512			
		rep movsd
		lss sp,[cs:InitStack]
		jmp 0:07C00h			

.int18:
		int 18h				
		jmp kaboom			

abort_check:
		call pollchar
		jz ac_ret1
		pusha
		call getchar
		cmp al,27			
		je ac_kill
		cmp al,3			
		jne ac_ret2


ac_kill:	
		mov si,aborted_msg

abort_load:
		mov ax,cs                       
		mov ds,ax
		mov es,ax
		cli
		lss sp,[cs:Stack]		
		sti
		call cwritestr                  


al_ok:
		jmp enter_command               

ac_ret2:	
		popa

ac_ret1:	
		ret

alloc_failure:
		xor ax,ax			
		ret

searchdir:
		xor al,al



searchdir_iso:
		mov [ISOFlags],al
		TRACER 'S'
		call allocate_file		
		jnz alloc_failure
		push es
		push ds
		pop es				
		mov si,CurDir
		cmp byte [di],'/'		
		jne .not_rooted
		inc di				
		mov si,RootDir			


.not_rooted:
		mov eax,[si+dir_clust]
		mov [bx+file_left],eax
		mov eax,[si+dir_lba]
		mov [bx+file_sector],eax
		mov edx,[si+dir_len]

.look_for_slash:
		mov ax,di



.scan:
		mov cl,[di]
		inc di
		and cl,cl
		jz .isfile
		cmp cl,'/'
		jne .scan
		mov [di-1],byte 0		
		mov cl,02h			
		xchg cl,[ISOFlags]
		push di				
		push cx
		push word .resume		
		push es


.isfile:	
		xchg ax,di

.getsome:
		mov si,trackbuf
		TRACER 'g'
		pushad
		xchg bx,si
		mov cx,[BufSafe]
		call getfssec
		popad

.compare:
		movzx eax,byte [si]		
		cmp al,33
		jb .next_sector
		TRACER 'c'
		mov cl,[si+25]
		xor cl,[ISOFlags]
		test cl, byte 8Eh		
		jnz .not_file
		pusha
		movzx cx,byte [si+32]		
		add si,byte 33			
		TRACER 'i'
		call iso_compare_names
		popa
		je .success


.not_file:
		sub edx,eax			
		jbe .failure
		add si,ax			

.check_overrun:
		cmp si,trackbuf+trackbufsize
		jb .compare			
		jmp short .getsome		

.next_sector:
		lea ax,[si+SECTORSIZE-1]
		and ax,~(SECTORSIZE-1)
		sub ax,si
		jmp short .not_file		

.failure:	
		xor eax,eax			
		mov [bx+file_sector],eax
		pop es
		ret

.success:
		mov eax,[si+2]			
		mov [bx+file_sector],eax
		mov eax,[si+10]			
		push eax
		add eax,SECTORSIZE-1
		shr eax,SECTORSIZE_LG2
		mov [bx+file_left],eax
		pop eax
		mov edx,eax
		shr edx,16
		and bx,bx			
		mov si,bx
		pop es
		ret

.resume:	
		xchg edx,eax			
		pop cx				
		pop di				
		mov byte [di-1], '/'		
		mov [ISOFlags],cl		
		jz .failure			
		jmp .look_for_slash		


allocate_file:
		TRACER 'a'
		push cx
		mov bx,Files
		mov cx,MAX_OPEN


.check:		
		cmp dword [bx], byte 0
		je .found
		add bx,open_file_t_size		
		loop .check
		
.found:		
		pop cx
		ret

iso_compare_names:
		push di
		mov di,ISOFileName


.canon_loop:	
		jcxz .canon_end
		lodsb
		dec cx
		cmp al,';'
		je .canon_end
		and al,al
		je .canon_end
		stosb
		cmp di,ISOFileNameEnd-1		
		jb .canon_loop


.canon_end:
		cmp di,ISOFileName
		jbe .canon_done
		cmp byte [di-1],'.'		
		jne .canon_done
		dec di
		jmp short .canon_end


.canon_done:
		mov [di],byte 0			
		pop di
		mov si,ISOFileName


.compare:
		lodsb
		mov ah,[di]
		inc di
		and ax,ax
		jz .success			
		and al,al			
		jz .failure			
		and ah,ah
		jz .failure
		or ax,2020h			
		cmp al,ah
		je .compare


.failure:	
		and ax,ax			

.success:	
		ret

strcpy:		
		push ax

.loop:		
		lodsb
		stosb
		and al,al
		jnz .loop
		pop ax
		ret

writechr_full:
		push ds
		push cs
		pop ds
		call write_serial	
		pushfd
		pushad
		mov bh,[TextPage]
		push ax
		mov ah,03h              
		int 10h
		pop ax
		cmp al,8
		je .bs
		cmp al,13
		je .cr
		cmp al,10
		je .lf
		push dx
		mov bh,[TextPage]
		mov bl,07h		
		mov cx,1		
		mov ah,09h		
		int 10h
		pop dx
		inc dl
		cmp dl,[VidCols]
		jna .curxyok
		xor dl,dl


.lf:		
		inc dh
		cmp dh,[VidRows]
		ja .scroll


.curxyok:	
		mov bh,[TextPage]
		mov ah,02h		
		int 10h			


.ret:		
		popad
		popfd
		pop ds
		ret


.scroll:	
		dec dh
		mov bh,[TextPage]
		mov ah,02h
		int 10h
		mov ax,0601h		
		mov bh,[ScrollAttribute]
		xor cx,cx
		mov dx,[ScreenSize]	
		int 10h
		jmp short .ret


.cr:		
		xor dl,dl
		jmp short .curxyok


.bs:		
		sub dl,1
		jnc .curxyok
		mov dl,[VidCols]
		sub dh,1
		jnc .curxyok
		xor dh,dh
		jmp short .curxyok


mangle_name:
		push bx
		xor ax,ax
		mov cx,FILENAME_MAX-1
		mov bx,di

.mn_loop:
		lodsb
		cmp al,' '			
		jna .mn_end
		cmp al,ah			
		je .mn_skip
		xor ah,ah
		cmp al,'/'
		jne .mn_ok
		mov ah,al
.mn_ok		stosb


.mn_skip:	
		loop .mn_loop

.mn_end:
		cmp bx,di			
		jbe .mn_zero
		cmp byte [di-1],'.'		
		je .mn_kill
		cmp byte [di-1],'/'		
		jne .mn_zero


.mn_kill:	
		dec di				
		inc cx
		jmp short .mn_end

.mn_zero:
		inc cx				
		xor ax,ax			
		rep stosb
		pop bx
		ret				

unmangle_name:	
		call strcpy
		dec di				
		ret


getfssec:
		TRACER 'F'
		push ds
		push cs
		pop ds				
		movzx ecx,cx
		cmp ecx,[si+file_left]
		jna .ok_size
		mov ecx,[si+file_left]


.ok_size:
		mov bp,cx
		push cx
		push si
		mov eax,[si+file_sector]
		TRACER 'l'
		call getlinsec
		xor ecx,ecx
		pop si
		pop cx
		add [si+file_sector],ecx
		sub [si+file_left],ecx
		ja .not_eof			
		xor ecx,ecx
		mov [si+file_sector],ecx	
		xor si,si
		stc

.not_eof:
		pop ds
		TRACER 'f'
		ret

%include "getc.inc"		
%include "conio.inc"		
%include "parseconfig.inc"	

getcommand:
.find:
    call skipspace    
    jz .eof     
    jc .find    
    cmp al,'0'    
    jb .skipline
    or al,20h   
    movzx ebx,al    


.read_loop:
    push ebx
    call getc
    pop ebx
    cmp al,' '    
    jbe .done
    or al,20h
    rol ebx,5
    xor bl,al
    jmp short .read_loop


.done:    
		call ungetc
    call skipspace
    jz .eof
    jc .noparm
    call ungetc   
    mov si,keywd_table
    mov cx,keywd_count


.table_search:
    lodsd
    cmp ebx,eax
    je .found_keywd
    lodsd     
    loop .table_search
    mov si,err_badcfg
    jmp short .error

.noparm:
    mov si,err_noparm


.error:
    call cwritestr
    jmp short .find

.found_keywd: 
		lodsw     
    call [si]
    clc
    ret

.eof:   
		stc
    ret

.skipline:  
		cmp al,10   
    je .find
    call getc
    jc .eof
    jmp short .skipline



%include "bcopy32.inc"		


load_high:
    push es
    mov bx,xfer_buf_seg
    mov es,bx

.read_loop:
    and si,si     
    jz .eof
    push si
    pop si
    call abort_check
    push eax      
    cmp eax,(1 << 16)   
    jna .size_ok
    mov eax,(1 << 16)


.size_ok:
    xor edx,edx
    push eax      
    div dword [ClustSize]   
    add edx,byte -1     
    adc eax,byte 0      
    push edi      
    mov cx,ax
    xor bx,bx     
    call getfssec     
    pop edi
    pop ecx
    push ecx      
    push edi      


.fix_slop:
    test cl,3
    jz .noslop
    mov byte [es:ecx],0
    inc ecx
    jmp short .fix_slop


.noslop:
    push esi      
    mov esi,(xfer_buf_seg << 4) 
    call bcopy      
    pop esi
    pop edi
    pop ecx
    pop eax
    add edi,ecx
    sub eax,ecx
    jnz .read_loop      

.eof:
    pop es
    ret


loadfont:
    mov bx,trackbuf     
    mov cx,[BufSafe]    
    call getfssec     
    mov ax,[trackbuf]   
    cmp ax,0436h
    jne lf_ret
    mov al,[trackbuf+2]   
    cmp al,5      
    ja lf_ret
    mov bh,byte [trackbuf+3]  
    cmp bh,2      
    jb lf_ret
    cmp bh,32     
    ja lf_ret
    mov si,trackbuf+4   
    mov [VGAFontSize],bh
    mov di,vgafontbuf
    mov cx,(32*256) >> 2    
    rep movsd
    mov [UserFont], byte 1    


use_font:
    test [UserFont], byte 1   
    jz adjust_screen    
    mov bp,vgafontbuf
    mov bh,[VGAFontSize]
    xor bl,bl     
    cmp [UsingVGA], byte 1    
    jne .text

.graphics:
    xor cx,cx
    mov cl,bh     
    mov ax,480
    div cl        
    mov dl,al
    dec al
    mov [VidRows],al
    mov ax,1121h      
    int 10h
    mov [VidCols], byte 79    
    mov [TextPage], byte 0    


.lf_ret:  
		ret       

.text:
    mov cx,256
    xor dx,dx
    mov ax,1110h
    int 10h       
    xor bl,bl
    mov ax,1103h      
    int 10h

lf_ret    equ use_font.lf_ret

adjust_screen:
		mov al,[BIOS_vidrows]
		and al,al
		jnz vidrows_ok
		mov al,24                       


vidrows_ok: 
		mov [VidRows],al
		mov ah,0fh
		int 10h                         
		mov [TextPage],bh
		dec ah                          
		mov [VidCols],ah
    ret

%include "graphics.inc"		


highmemsize:
    push es
    pushad

get_e820:
    xor ebx,ebx     
    mov es,bx     
    jmp short .do_e820    


.int_loop:  
		and ebx,ebx     
    jz no_e820      


.do_e820: 
		mov eax,0000E820h
    mov edx,534D4150h   
    xor ecx,ecx
    mov cl,20     
    mov di,E820Buf
    int 15h
    jc no_e820
    cmp eax,534D4150h
    jne no_e820
    cmp dword [E820Buf+4], byte 0
    ja .int_loop      
    mov edx, (1 << 20)
    sub edx, [E820Buf]
    jb .int_loop      
    stc
    sbb eax,eax     
    cmp dword [E820Buf+12], byte 0
    ja .huge      
    mov eax, [E820Buf+8]


.huge:    
		sub eax, edx      
    jbe .int_loop     
    cmp dword [E820Buf+16], byte 1
    jne near err_nohighmem    
    jmp short got_highmem_add1mb  

no_e820:
    mov ax,0e801h     
    int 15h
    jc no_e801
    cmp ax,3c00h
    ja no_e801      
    jb e801_hole      
    mov ax,bx
    shl eax,16      
    add eax,(16 << 20)    
    jmp short got_highmem

no_e801:
    mov ah,88h      
    int 15h
    cmp ax,14*1024      
    jna e801_hole
    mov ax,14*1024


e801_hole:
    and eax,0ffffh
    shl eax,10      


got_highmem_add1mb:
    add eax,(1 << 20)   


got_highmem:
%if HIGHMEM_SLOP != 0
    sub eax,HIGHMEM_SLOP
%endif
    mov [HighMemSize],eax
    popad
    pop es
    ret

CR		equ 13		
LF		equ 10		
FF		equ 12		
BS		equ  8		

boot_prompt		db 'boot: ', 0
wipe_char			db BS, ' ', BS, 0
err_notfound	db 'Could not find kernel image: ',0
err_notkernel	db CR, LF, 'Invalid or corrupt kernel image.', CR, LF, 0
err_noram	db 'It appears your computer has less than '
		asciidec dosram_k
		db 'K of low ("DOS")'
		db CR, LF
		db 'RAM.  Linux needs at least this amount to boot.  If you get'
		db CR, LF
		db 'this message in error, hold down the Ctrl key while'
		db CR, LF
		db 'booting, and I will take your word for it.', CR, LF, 0
err_badcfg      db 'Unknown keyword in config file.', CR, LF, 0
err_noparm      db 'Missing parameter in config file.', CR, LF, 0
err_noinitrd    db CR, LF, 'Could not find ramdisk image: ', 0
err_nohighmem   db 'Not enough memory to load specified kernel.', CR, LF, 0
err_highload    db CR, LF, 'Kernel transfer failure.', CR, LF, 0
err_oldkernel   db 'Cannot load a ramdisk with an old kernel image.'
                db CR, LF, 0
err_notdos			db ': attempted DOS system call', CR, LF, 0
err_comlarge		db 'COMBOOT image too large.', CR, LF, 0
err_bssimage		db 'BSS images not supported.', CR, LF, 0
err_a20					db CR, LF, 'A20 gate not responding!', CR, LF, 0
notfound_msg		db 'not found', CR, LF, 0
localboot_msg		db 'Booting from local disk...', CR, LF, 0
cmdline_msg			db 'Command line: ', CR, LF, 0
strLoadMsg 			db 'Loading VaultOS. Please wait...',CR,LF,0
trying_msg			db 'Trying to load: ', 0
crlfloading_msg	db CR, LF			
loading_msg     db 'Loading ', 0
dotdot_msg      db '.'
dot_msg         db '.', 0
fourbs_msg			db BS, BS, BS, BS, 0
aborted_msg			db ' aborted.', CR, LF, 0
crff_msg				db CR, FF, 0
default_str			db 'default', 0
default_len			equ ($-default_str)
boot_dir				db '/boot'			
isolinux_dir		db '/isolinux', 0
isolinux_cfg		db 'isolinux.cfg', 0
err_disk_image	db 'Cannot load disk image (invalid file)?', CR, LF, 0
initrd_cmd			db 'initrd='
initrd_cmd_len	equ 7

%ifndef DEPEND
hash_hash               equ 0x00000023
hash_append             equ 0xc53999a4
hash_default            equ 0xcc5159ed
hash_display            equ 0xd509bc40
hash_font               equ 0x0032b1b4
hash_implicit           equ 0xa6f50207
hash_ipappend           equ 0xc5399af0
hash_kbdmap             equ 0xd013b850
hash_kernel             equ 0xd068b4cc
hash_label              equ 0x06f104cc
hash_localboot          equ 0x04f0def4
hash_prompt             equ 0xe7163a74
hash_say                equ 0x0001c059
hash_serial             equ 0xe068a84c
hash_timeout            equ 0xd4e332c9
hash_f0                 equ 0x00000cf0
hash_f1                 equ 0x00000cf1
hash_f2                 equ 0x00000cf2
hash_f3                 equ 0x00000cf3
hash_f4                 equ 0x00000cf4
hash_f5                 equ 0x00000cf5
hash_f6                 equ 0x00000cf6
hash_f7                 equ 0x00000cf7
hash_f8                 equ 0x00000cf8
hash_f9                 equ 0x00000cf9
hash_f10                equ 0x00019e10
hash_f11                equ 0x00019e11
hash_f12                equ 0x00019e12
%endif

%macro keyword 2
  dd hash_%1  
  dw 0    
  dw %2   
%endmacro

%macro keyword 3
  dd hash_%1  
  dw %3   
  dw %2   
%endmacro

%macro keyword 4
  dd hash_%1  
  db %3, %4 
  dw %2   
%endmacro

keywd_size  equ 8 

    align 4, db 0

keywd_table:
    keyword hash,      pc_comment
    keyword append,    pc_append
    keyword default,   pc_default
    keyword display,   pc_filecmd,  get_msg_file
    keyword font,      pc_filecmd,  loadfont
    keyword implicit,  pc_setint16, AllowImplicit
    keyword kbdmap,    pc_filecmd,  loadkeys
    keyword kernel,    pc_kernel
    keyword label,     pc_label
    keyword prompt,    pc_setint16, ForcePrompt
    keyword say,       pc_say
    keyword serial,    pc_serial
    keyword timeout,   pc_timeout
    keyword f1,        pc_fkey,     FKeyName+(0<<FILENAME_MAX_LG2)
    keyword f2,        pc_fkey,     FKeyName+(1<<FILENAME_MAX_LG2)
    keyword f3,        pc_fkey,     FKeyName+(2<<FILENAME_MAX_LG2)
    keyword f4,        pc_fkey,     FKeyName+(3<<FILENAME_MAX_LG2)
    keyword f5,        pc_fkey,     FKeyName+(4<<FILENAME_MAX_LG2)
    keyword f6,        pc_fkey,     FKeyName+(5<<FILENAME_MAX_LG2)
    keyword f7,        pc_fkey,     FKeyName+(6<<FILENAME_MAX_LG2)
    keyword f8,        pc_fkey,     FKeyName+(7<<FILENAME_MAX_LG2)
    keyword f9,        pc_fkey,     FKeyName+(8<<FILENAME_MAX_LG2)
    keyword f10,       pc_fkey,     FKeyName+(9<<FILENAME_MAX_LG2)
    keyword f0,        pc_fkey,     FKeyName+(9<<FILENAME_MAX_LG2)
%if IS_PXELINUX
    keyword ipappend,  pc_ipappend
%endif
%if IS_PXELINUX || IS_ISOLINUX
    keyword localboot, pc_localboot
%endif

keywd_count equ ($-keywd_table)/keywd_size

align 4, db 0
exten_table:	
		db '.cbt'		
		db '.img'		
		db '.bin'		
		db '.com'		
exten_table_end:
		dd 0, 0			
		align 4, db 0

img_table_count	equ 3
img_table:
		dd 1200*1024		
		db 1			
		db 80-1			
		db 15			
		db 2-1			

		dd 1440*1024		
		db 2			
		db 80-1			
		db 18			
		db 2-1			

		dd 2880*1024		
		db 3			
		db 80-1			
		db 36			
		db 2-1			

AppendLen       dw 0                    
KbdTimeOut      dw 0                    
CmdLinePtr			dw cmd_line_here	
initrd_flag			equ $
initrd_ptr			dw 0			
VKernelCtr			dw 0			
ForcePrompt			dw 0			
AllowImplicit   dw 1                    
SerialPort			dw 0			
NextSocket			dw 49152		
VGAFontSize			dw 16			
UserFont				db 0			
ScrollAttribute	db 07h			
alignb 4, 			db 0
ClustSize				dd SECTORSIZE		
ClustPerMoby		dd 65536/SECTORSIZE	
SecPerClust			dw 1			
BufSafe					dw trackbufsize/SECTORSIZE	
BufSafeSec			dw trackbufsize/SECTORSIZE	
BufSafeBytes		dw trackbufsize		
EndOfGetCBuf		dw getcbuf+trackbufsize	
%ifndef DEPEND
%if ( trackbufsize % SECTORSIZE ) != 0
%error trackbufsize must be a multiple of SECTORSIZE
%endif
%endif


linuxauto_cmd		db 'linux auto',0
linuxauto_len   equ $-linuxauto_cmd
boot_image      db 'BOOT_IMAGE='
boot_image_len  equ $-boot_image
                align 4, db 0		
command_line		equ $
default_cmd			equ $+(max_cmd_len+2)
ldlinux_end			equ default_cmd+(max_cmd_len+1)
kern_cmd_len    equ ldlinux_end-command_line
end_of_code			equ (ldlinux_end-bootsec)+7C00h
getcbuf					equ (end_of_code + 511) & 0FE00h
vgafontbuf			equ 0E000h

%ifndef DEPEND
%if (getcbuf+trackbufsize) > vgafontbuf
%error "Out of memory, better reorganize something..."
%endif
%endif



