
pc_default:	
		mov di,default_cmd
		call getline
		xor al,al
		stosb				
		ret

pc_append:      
		cmp word [VKernelCtr],byte 0
		ja .vk
		mov di,AppendBuf
		call getline
		sub di,AppendBuf

.app1:        	
		mov [AppendLen],di
		ret

.vk:		
		mov di,VKernelBuf+vk_append	
		call getline
		sub di,VKernelBuf+vk_append
		cmp di,byte 2
		jne .app2
		cmp byte [VKernelBuf+vk_append],'-'
		jne .app2
		xor di,di			

.app2:		
		mov [VKernelBuf+vk_appendlen],di
		ret

%if IS_PXELINUX
pc_ipappend:	
		call getint
		jc .err
		and bx,bx
		setnz bl
		cmp word [VKernelCtr], byte 0
		jne .vk
		mov [IPAppend],bl

.err:		
		ret

.vk:		
		mov [VKernelBuf+vk_ipappend],bl
		ret
%endif

%if IS_PXELINUX || IS_ISOLINUX
pc_localboot:	
		call getint
		cmp word [VKernelCtr],byte 0	
		je .err
		mov [VKernelBuf+vk_rname], byte 0	
		mov [VKernelBuf+vk_rname+1], bx	

.err:		
		ret
%endif

pc_kernel:	
		cmp word [VKernelCtr],byte 0
		je .err				
		call pc_getline
		mov di,VKernelBuf+vk_rname
		call mangle_name

.err:		
		ret

pc_timeout:	
		call getint
		jc .err
		mov ax,0D215h			
		mul bx				
		add bx,dx
		mov [KbdTimeOut],bx

.err:		
		ret

pc_setint16:
		push ax
		call getint
		pop si
		jc .err
		mov [si],bx

.err:		
		ret

pc_filecmd:	
		push ax				
		call pc_getline
		mov di,MNameBuf
		push di
		call mangle_name
		pop di
		call searchdir			
		jnz .ok
		pop ax				

.ok:		
		ret				

pc_serial:	
		call getint
		jc .err
		push bx				
		call skipspace
		jnc .ok
		pop bx

.err:		
		ret

.ok:
		call ungetc
		call getint
		mov [FlowControl], word 0	
		jc .nobaud

.valid_baud:	
		push ebx
		call skipspace
		jc .no_flow
		call ungetc
		call getint			
		jnc .valid_flow

.no_flow:
		xor bx,bx			

.valid_flow:
		and bh,0Fh			
		shl bh,4
		mov [FlowIgnore],bh
		mov bh,bl
		and bx,0F003h			
		mov [FlowControl],bx
		pop ebx				
		jmp short .parse_baud

.nobaud:
		mov ebx,DEFAULT_BAUD		

.parse_baud:
		pop di				
		cmp ebx,byte 75
		jb .err				
		mov eax,BAUD_DIVISOR
		cdq
		div ebx
		mov [BaudDivisor],ax
		push ax				
		cmp di,3
		ja .port_is_io			
		shl di,1
		mov di,[di+serial_base]		

.port_is_io:
		mov [SerialPort],di
		lea dx,[di+3]			
		mov al,83h			
		call slow_out
		pop ax				
		mov dx,di			
		call slow_out
		inc dx				
		mov al,ah
		call slow_out
		mov al,03h			
		add dx,byte 2			
		call slow_out
		in al,dx			
		cmp al,03h			
		jne .serial_port_bad		
		sub dx,byte 2			
		xor al,al			
		call slow_out
		add dx,byte 3			
		in al,dx
		or al,[FlowOutput]		
		call slow_out
		call write_serial_str
		call write_serial_str
		ret

.serial_port_bad:
		mov [SerialPort], word 0
		ret

pc_fkey:	
		push ax
		call pc_getline
		pop di
		call mangle_name		
		ret

pc_label:	
		call commit_vk			
		call pc_getline
		mov di,VKernelBuf+vk_vname
		call mangle_name		
		inc word [VKernelCtr]		
		mov si,VKernelBuf+vk_vname 	
		mov di,VKernelBuf+vk_rname
		mov cx,FILENAME_MAX
		rep movsb
		mov si,AppendBuf         	
		mov di,VKernelBuf+vk_append
		mov cx,[AppendLen]
		mov [VKernelBuf+vk_appendlen],cx
		rep movsb

%if IS_PXELINUX					
		mov al,[IPAppend]		
		mov [VKernelBuf+vk_ipappend],al
%endif
		ret

pc_say:		
		call pc_getline			
		call writestr
		jmp crlf			

pc_comment	equ pc_getline			

pc_getline:	
		mov di,trackbuf
		push di
		call getline
		xor al,al
		stosb				
		pop si
		ret

parse_config:
		call getcommand
		jnc parse_config		

commit_vk:
		cmp word [VKernelCtr],byte 0
		je cvk_ret			
		cmp word [VKernelCtr],max_vk	
		ja cvk_overflow
		mov di,[VKernelCtr]
		dec di
		shl di,vk_shift
		mov si,VKernelBuf
		mov cx,(vk_size >> 2)
		push es
		push word vk_seg
		pop es
		rep movsd			
		pop es

cvk_ret:	
		ret

cvk_overflow:	
		mov word [VKernelCtr],max_vk
		ret



