

#ifndef DRGZ_H
#define DRGZ_H

#include <ctype.h>
#include <sys/types.h>
#include <signal.h>
#include <stdarg.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/stat.h>
#include <errno.h>
#include <utime.h>
#include <memory.h>
#include <unistd.h>
#include <sys/file.h>


typedef unsigned char  uch;
typedef unsigned short ush;
typedef unsigned long  ulg;
typedef unsigned long  BooleanT;

#define TRUE						1
#define FALSE						0
#define DEFLATED    		8
#define INBUFSIZ  			0x8000
#define INBUF_EXTRA  		64
#define OUTBUFSIZ  			16384
#define OUTBUF_EXTRA 		2048
#define DIST_BUFSIZE 		0x8000
#define	GZIP_MAGIC     	"\037\213"
#define	OLD_GZIP_MAGIC 	"\037\236"
#define CONTINUATION 		0x02
#define EXTRA_FIELD  		0x04
#define ORIG_NAME    		0x08
#define COMMENT      		0x10
#define ENCRYPTED    		0x20
#define RESERVED     		0xC0
#define WSIZE 					0x8000

#define EXTERN(type, array)  extern type array[]
#define DECLARE(type, array, size)  type array[size]
#define ALLOC(type, array, size)
#define FREE(array)

#define GET_BYTE()  (glInPtr < glInSizeGz ? gBufferIn[glInPtr++] : FillBuffer(0))
#define TRY_BYTE()  (glInPtr < glInSizeGz ? gBufferIn[glInPtr++] : FillBuffer(1))
#define SH(p) 			((ush)(uch)((p)[0]) | ((ush)(uch)((p)[1]) << 8))
#define LG(p) 			((ulg)(SH(p)) | ((ulg)(SH((p)+2)) << 16))
#define Tracev(x)
#define Tracevv(x)
#define Tracecv(c,x)


EXTERN(uch, gBufferIn);
EXTERN(uch, gBufferOut);
EXTERN(uch, gBufferWin);

extern int  		glInFd;
extern int  		glOutFd;
extern char 		gstrInFile[];
extern char 		gstrOutFile[];
extern off_t 		glBytesIn;
extern off_t 		glBytesOut;
extern unsigned glOutSizeGz;
extern unsigned glInSizeGz;
extern unsigned glInPtr;

extern void ZLOGGZ					(BooleanT, int, const char *, ...);
extern ulg  ConvertCRC    	(uch *, unsigned);
extern void ClearBuffer   	();
extern int  FillBuffer    	(int);
extern void FlushBufferGz 	();
extern void FlushBufferWin  ();
extern void WriteBuffer   	(int, void *, unsigned);
extern int 	DrDecompress		();

#endif
