
#include "drgz.h"

struct tHuffman 
{
  uch e;
  uch b;
  union 
	{
    ush n;
    struct tHuffman *t;
  } v;
};


#define BMAX 16
#define N_MAX 288
#define wp glOutSizeGz
#define FLUSH_OUTPUT(w) (wp=(w),FlushBufferWin())

static unsigned border[] 	= { 16, 17, 18, 0, 8, 7, 9, 6, 10, 5, 11, 4, 12, 3, 13, 2, 14, 1, 15};
static ush cplens[] 			= { 3, 4, 5, 6, 7, 8, 9, 10, 11, 13, 15, 17, 19, 23, 27, 31, 35, 43, 51, 
															59, 67, 83, 99, 115, 131, 163, 195, 227, 258, 0, 0};
static ush cplext[] 			= { 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 2, 2, 2, 2, 3, 3, 
															3, 3, 4, 4, 4, 4, 5, 5, 5, 5, 0, 99, 99}; 
static ush cpdist[] 			= { 1, 2, 3, 4, 5, 7, 9, 13, 17, 25, 33, 49, 65, 97, 129, 193, 257, 385, 
															513, 769, 1025, 1537, 2049, 3073, 4097, 6145, 8193, 12289, 16385, 24577};
static ush cpdext[] 			= { 0, 0, 0, 0, 1, 1, 2, 2, 3, 3, 4, 4, 5, 5, 6, 6, 7, 7, 8, 8, 9, 9, 10, 10, 
															11, 11, 12, 12, 13, 13};
ush mask_bits[] 					= { 0x0000, 0x0001, 0x0003, 0x0007, 0x000f, 0x001f, 0x003f, 0x007f, 0x00ff, 
															0x01ff, 0x03ff, 0x07ff, 0x0fff, 0x1fff, 0x3fff, 0x7fff, 0xffff };

#define GETBYTE() 	(glInPtr < glInSizeGz ? gBufferIn[glInPtr++] : (wp = w, FillBuffer(0)))
#define NEXTBYTE()  (uch)GETBYTE()
#define NEEDBITS(n) {while(k<(n)){b|=((ulg)NEXTBYTE())<<k;k+=8;}}
#define DUMPBITS(n) {b>>=(n);k-=(n);}

int 			lbits = 9;
int 			dbits = 6;
ulg 			bb;
unsigned 	bk;
unsigned 	glHuffCount;



/*
** ====================================================================
** ====================================================================
*/
static int FreeHuff (struct tHuffman *t)
{
  register struct tHuffman *p, *q;
  p = t;
  while (p != (struct tHuffman *)NULL)
  {
    q = (--p)->v.t;
    free ((char*)p);
    p = q;
  } 
  return 0;
}


/*
** ====================================================================
** ====================================================================
*/
static int 	BuildHuff (
						unsigned *b,
						unsigned n,
						unsigned s,
						ush *d,
						ush *e,
						struct tHuffman **t,
						int *m)
{
  unsigned a;
  unsigned c[BMAX+1];
  unsigned f;
  int g;
  int h;
  register unsigned i;
  register unsigned j;
  register int k;
  int l;
  register unsigned *p;
  register struct tHuffman *q;
  struct tHuffman r;
  struct tHuffman *u[BMAX];
  unsigned v[N_MAX];
  register int w;
  unsigned x[BMAX+1];
  unsigned *xp;
  int y;
  unsigned z;

  memset (c, 0, sizeof(c));
  p = b;  i = n;
  do 
	{
    Tracecv(*p, (stderr, (n-i >= ' ' && n-i <= '~' ? "%c %d\n" : "0x%x %d\n"), n-i, *p));
    c[*p]++;
    p++;
  } while (--i);

  if (c[0] == n)
  {
    *t = (struct tHuffman *)NULL;
    *m = 0;
    return 0;
  }
  l = *m;

  for (j = 1; j <= BMAX; j++)
	{
    if (c[j]) break;
	}
  k = j; 

  if ((unsigned)l < j) l = j;

  for (i = BMAX; i; i--)
	{
    if (c[i]) break;
	}
  g = i;
  if ((unsigned)l > i) l = i;
  *m = l;

  for (y = 1 << j; j < i; j++, y <<= 1)
	{
    if ((y -= c[j]) < 0) return 2;
	}
  if ((y -= c[i]) < 0) return 2;
  c[i] += y;

  x[1] = j = 0;
  p = c + 1;  xp = x + 2;
  while (--i) 
	{
    *xp++ = (j += *p++);
  }

  p = b;  i = 0;
  do 
	{
    if ((j = *p++) != 0) v[x[j]++] = i;
  } while (++i < n);

  n = x[g];
  x[0] = i = 0;                 
  p = v;                        
  h = -1;                       
  w = -l;                       
  u[0] = (struct tHuffman *)NULL;   
  q = (struct tHuffman *)NULL;      
  z = 0;                        

  for (; k <= g; k++)
  {
    a = c[k];
    while (a--)
    {
      while (k > w + l)
      {
        h++;
        w += l;                 
        z = (z = g - w) > (unsigned)l ? l : z;  

        if ((f = 1 << (j = k - w)) > a + 1)     
				{
					f -= a + 1;
					xp = c + k;
					if (j < z)
					{
						while (++j < z)
						{
							if ((f <<= 1) <= *++xp) break;
							f -= *xp;
						}
					}
				}
        z = 1 << j;             
        
        if ((q = (struct tHuffman *)malloc((z + 1)*sizeof(struct tHuffman))) == (struct tHuffman *)NULL)
        {
          if (h) FreeHuff(u[0]);
          return 3;             
        }
        glHuffCount += z + 1;         
        *t = q + 1;             
        *(t = &(q->v.t)) = (struct tHuffman *)NULL;
        u[h] = ++q;             
        
        if (h)
        {
          x[h] = i;             
          r.b = (uch)l;         
          r.e = (uch)(16 + j);  
          r.v.t = q;            
          j = i >> (w - l);     
          u[h-1][j] = r;        
        }
      }
      r.b = (uch)(k - w);
      if (p >= v + n) 
			{
				r.e = 99;               
			}
      else if (*p < s)
      {
        r.e = (uch)(*p < 256 ? 16 : 15);    
        r.v.n = (ush)(*p);             
				p++;                           
      }
      else
      {
        r.e = (uch)e[*p - s];   
        r.v.n = d[*p++ - s];
      }
      f = 1 << (k - w);

      for (j = i >> w; j < z; j += f) q[j] = r;
      for (j = 1 << (k - 1); i & j; j >>= 1) i ^= j;
      i ^= j;
      
      while ((i & ((1 << w) - 1)) != x[h])
      {
        h--;                    
        w -= l;
      }
    }
  }
  return y != 0 && g != 1;
}





/*
** ====================================================================
** ====================================================================
*/
static int 	DecompressCode (
						struct tHuffman *tl,
						struct tHuffman *td,
						int bl,
						int bd)             

{
  register unsigned e;  
  unsigned n, d;        
  unsigned w;           
  struct tHuffman *t;       
  unsigned ml, md;      
  register ulg b;       
  register unsigned k;  
  
  b = bb;                       
  k = bk;
  w = wp;                       
  ml = mask_bits[bl];           
  md = mask_bits[bd];

  for (;;)                      
  {
    NEEDBITS((unsigned)bl)
    if ((e = (t = tl + ((unsigned)b & ml))->e) > 16)
		{
      do 
			{
        if (e == 99) return 1;
        DUMPBITS(t->b)
        e -= 16;
        NEEDBITS(e)
      } while ((e = (t = t->v.t + ((unsigned)b & mask_bits[e]))->e) > 16);
		}
    DUMPBITS(t->b)
    if (e == 16)                
    {
      gBufferWin[w++] = (uch)t->v.n;
      Tracevv((stderr, "%c", gBufferWin[w-1]));
      if (w == WSIZE)
      {
        FLUSH_OUTPUT(w);
        w = 0;
      }
    }
    else                        
    {
      if (e == 15) break;
      
      NEEDBITS(e)
      n = t->v.n + ((unsigned)b & mask_bits[e]);
      DUMPBITS(e);
      NEEDBITS((unsigned)bd)
      if ((e = (t = td + ((unsigned)b & md))->e) > 16)
			{
        do 
				{
          if (e == 99) return 1;
          DUMPBITS(t->b)
          e -= 16;
          NEEDBITS(e)
        } while ((e = (t = t->v.t + ((unsigned)b & mask_bits[e]))->e) > 16);
			}
      DUMPBITS(t->b)
      NEEDBITS(e)
      d = w - t->v.n - ((unsigned)b & mask_bits[e]);
      DUMPBITS(e)
      Tracevv((stderr,"\\[%d,%d]", w-d, n));
      
			do 
			{
        n -= (e = (e = WSIZE - ((d &= WSIZE-1) > w ? d : w)) > n ? n : e);
        if (w - d >= e)         
        {
          memcpy(gBufferWin + w, gBufferWin + d, e);
          w += e;
          d += e;
        }
        else                      
				{
          do 
					{
            gBufferWin[w++] = gBufferWin[d++];
						Tracevv((stderr, "%c", gBufferWin[w-1]));
          } while (--e);
				}
        if (w == WSIZE)
        {
          FLUSH_OUTPUT(w);
          w = 0;
        }
      } while (n);
    }
  }
  wp = w;                       
  bb = b;                       
  bk = k;

  return 0;
}



/*
** ====================================================================
** ====================================================================
*/
static int DecompressStore ()
{
  unsigned n;           
  unsigned w;           
  register ulg b;       
  register unsigned k;  
  
  b = bb;                       
  k = bk;
  w = wp;                       
  
  n = k & 7;
  DUMPBITS(n);
  NEEDBITS(16)
  n = ((unsigned)b & 0xffff);
  DUMPBITS(16)
  NEEDBITS(16)
  if (n != (unsigned)((~b) & 0xffff)) return 1;                   
  DUMPBITS(16)
  
  while (n--)
  {
    NEEDBITS(8)
    gBufferWin[w++] = (uch)b;
    if (w == WSIZE)
    {
      FLUSH_OUTPUT(w);
      w = 0;
    }
    DUMPBITS(8)
  }
  wp = w;                       
  bb = b;                       
  bk = k;

  return 0;
}



/*
** ====================================================================
** ====================================================================
*/
static int DecompressFix ()
{
  int i;                
  struct tHuffman *tl;      
  struct tHuffman *td;      
  int bl;               
  int bd;               
  unsigned l[288];      

  for (i = 0; i < 144; i++) l[i] = 8;
  for (; i < 256; i++) 			l[i] = 9;
  for (; i < 280; i++) 			l[i] = 7;
  for (; i < 288; i++)			l[i] = 8;
  bl = 7;

  if ((i = BuildHuff (l, 288, 257, cplens, cplext, &tl, &bl)) != 0) return i;
  
  for (i = 0; i < 30; i++)      l[i] = 5;
  bd = 5;

  if ((i = BuildHuff (l, 30, 0, cpdist, cpdext, &td, &bd)) > 1)
  {
    FreeHuff(tl);
    return i;
  }
  if (DecompressCode (tl, td, bl, bd)) return 1;
  
  FreeHuff(tl);
  FreeHuff(td);
  return 0;
}



/*
** ====================================================================
** ====================================================================
*/
static int DecompressDynamic ()
{
  int i;                
  unsigned j;
  unsigned l;           
  unsigned m;           
  unsigned n;           
  unsigned w;           
  struct tHuffman *tl;      
  struct tHuffman *td;      
  int bl;               
  int bd;               
  unsigned nb;          
  unsigned nl;          
  unsigned nd;          
  unsigned ll[286+30];  
  register ulg b;       
  register unsigned k;  

  b = bb;
  k = bk;
  w = wp;
  
  NEEDBITS(5)
  nl = 257 + ((unsigned)b & 0x1f);      
  DUMPBITS(5)
  NEEDBITS(5)
  nd = 1 + ((unsigned)b & 0x1f);        
  DUMPBITS(5)
  NEEDBITS(4)
  nb = 4 + ((unsigned)b & 0xf);         
  DUMPBITS(4)
  if (nl > 286 || nd > 30)
    return 1;                   

  for (j = 0; j < nb; j++)
  {
    NEEDBITS(3)
    ll[border[j]] = (unsigned)b & 7;
    DUMPBITS(3)
  }
  for (; j < 19; j++) ll[border[j]] = 0;
  
  bl = 7;
  if ((i = BuildHuff (ll, 19, 19, NULL, NULL, &tl, &bl)) != 0)
  {
    if (i == 1) FreeHuff(tl);
    return i;                   
  }
  if (tl == NULL)		return 2;
  
  n = nl + nd;
  m = mask_bits[bl];
  i = l = 0;
  while ((unsigned)i < n)
  {
    NEEDBITS((unsigned)bl)
    j = (td = tl + ((unsigned)b & m))->b;
    DUMPBITS(j)
    j = td->v.n;
    if (j < 16)                 
		{
      ll[i++] = l = j;          
		}
    else if (j == 16)           
    {
      NEEDBITS(2)
      j = 3 + ((unsigned)b & 3);
      DUMPBITS(2)
      if ((unsigned)i + j > n) return 1;
      while (j--) ll[i++] = l;
    }
    else if (j == 17)           
    {
      NEEDBITS(3)
      j = 3 + ((unsigned)b & 7);
      DUMPBITS(3)
      if ((unsigned)i + j > n) return 1;
      while (j--) ll[i++] = 0;
      l = 0;
    }
    else                        
    {
      NEEDBITS(7)
      j = 11 + ((unsigned)b & 0x7f);
      DUMPBITS(7)
      if ((unsigned)i + j > n) return 1;
      while (j--) ll[i++] = 0;
      l = 0;
    }
  }
  FreeHuff(tl);
  
  bb = b;
  bk = k;
  
  bl = lbits;
  if ((i = BuildHuff (ll, nl, 257, cplens, cplext, &tl, &bl)) != 0)
  {
    if (i == 1) 
		{
      FreeHuff(tl);
    }
    return i;                   
  }
  bd = dbits;
  if ((i = BuildHuff (ll + nl, nd, 0, cpdist, cpdext, &td, &bd)) != 0)
  {
    if (i == 1) 
		{
      FreeHuff(td);
    }
    FreeHuff(tl);
    return i;                   
  }
  if (DecompressCode (tl, td, bl, bd)) return 1;
  
  FreeHuff(tl);
  FreeHuff(td);

  return 0;
}



/*
** ====================================================================
** ====================================================================
*/
static int DecompressBlock (int *e)
{
  unsigned t;           
  unsigned w;           
  register ulg b;       
  register unsigned k;  
  
  b = bb;
  k = bk;
  w = wp;
  
  NEEDBITS(1)
  *e = (int)b & 1;
  DUMPBITS(1)
  NEEDBITS(2)
  t = (unsigned)b & 3;
  DUMPBITS(2)
  
  bb = b;
  bk = k;
  
  if (t == 2) return DecompressDynamic();
  if (t == 0) return DecompressStore();
  if (t == 1) return DecompressFix();
  
  return 2;
}



/*
** ====================================================================
** ====================================================================
*/
extern int DrDecompress ()
{
  int 			e;                
  int 			r;                
  unsigned 	h;           
  
  wp = 0;
  bk = 0;
  bb = 0;
  
  h = 0;
  do
	{
    glHuffCount = 0;
    if ((r = DecompressBlock(&e)) != 0) return r;
    if (glHuffCount > h) h = glHuffCount;
  } while (!e);

  while (bk >= 8) 
	{
    bk -= 8;
    glInPtr--;
  }
  FLUSH_OUTPUT(wp);
  
  return 0;
}
