#ifndef DRIFCFG_H
#define DRIFCFG_H

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <ctype.h>
#include <errno.h>
#include <netdb.h>
#include <resolv.h>
#include <unistd.h>
#include <fcntl.h>

#include <arpa/inet.h>
#include <arpa/nameser.h>
#include <asm/types.h>

#include <sys/socket.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/ioctl.h>
#include <net/if.h>
#include <net/if_arp.h>
#include <net/route.h>
#include <netinet/in.h>

typedef struct
{
    char 		*pstrName;
    char 		*pstrTitle;
    int 		lDomain;
    int 		lLength;
    char 		*(*PrintCB) 	(unsigned char *);
    char 		*(*SprintCB) 	(struct sockaddr *, int);
    int 		(*InputCB) 		(int, char *, struct sockaddr *);
    void 		(*ErrorCB) 		(char *);
    int 		(*RprintCB) 	(int);
    int 		(*RinputCB) 	(int, int, char **);
    int 		(*GetMaskCB) 	(char *, struct sockaddr *, char *);
    int 		lFd;
    char 		*pstrFfile;
} NetDomainT;

extern NetDomainT 	*gtNetDomain[];
extern NetDomainT		*GetNetDomain			(const char *);
extern int					GetNetDomainSock	(int);


#endif
