
#ifndef DRIO_H
#define DRIO_H

#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <stdarg.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <utime.h>
#include "driosys.h"


/*
** =================================================================
** Types and Definitions
** =================================================================
*/
#define DISK_IO_BLOCK_SIZE  512
#ifndef NULL
#define NULL 0
#endif
typedef long								BooleanT;
typedef	unsigned char				ByteT;

enum AFormatT
{
	arf_unknown,
	arf_binary,
	arf_oldascii,
	arf_newascii,
	arf_crcascii,
	arf_tar,
	arf_ustar,
	arf_hpoldascii,
	arf_hpbinary
};


typedef struct
{
  unsigned short 	c_magic;
  unsigned long 	c_ino;
  unsigned long 	c_mode;
  unsigned long 	c_uid;
  unsigned long 	c_gid;
  unsigned long 	c_nlink;
  unsigned long 	c_mtime;
  unsigned long 	c_filesize;
  long 						c_dev_maj;
  long 						c_dev_min;
  long 						c_rdev_maj;
  long 						c_rdev_min;
  unsigned long 	c_namesize;
  unsigned long 	c_chksum;
  char 						*c_name;
  char 						*c_tar_linkname;
} zcpHeaderT;


struct tDelay
{
	zcpHeaderT 		tHdr;
	struct tDelay	*pNext;
};



/*
** =================================================================
** Definitions
** =================================================================
*/
#if !defined(S_ISBLK) && defined(S_IFBLK)
#define	S_ISBLK(m) (((m) & S_IFMT) == S_IFBLK)
#endif
#if !defined(S_ISCHR) && defined(S_IFCHR)
#define	S_ISCHR(m) (((m) & S_IFMT) == S_IFCHR)
#endif
#if !defined(S_ISDIR) && defined(S_IFDIR)
#define	S_ISDIR(m) (((m) & S_IFMT) == S_IFDIR)
#endif
#if !defined(S_ISREG) && defined(S_IFREG)
#define	S_ISREG(m) (((m) & S_IFMT) == S_IFREG)
#endif
#if !defined(S_ISFIFO) && defined(S_IFIFO)
#define	S_ISFIFO(m) (((m) & S_IFMT) == S_IFIFO)
#endif
#if !defined(S_ISLNK) && defined(S_IFLNK)
#define	S_ISLNK(m) (((m) & S_IFMT) == S_IFLNK)
#endif
#if !defined(S_ISSOCK) && defined(S_IFSOCK)
#define	S_ISSOCK(m) (((m) & S_IFMT) == S_IFSOCK)
#endif
#if !defined(S_ISNWK) && defined(S_IFNWK)
#define S_ISNWK(m) (((m) & S_IFMT) == S_IFNWK)
#endif

#define	CP_IFMT 0170000

#if defined(S_ISBLK)
#define CP_IFBLK 0060000
#endif
#if defined(S_ISCHR)
#define CP_IFCHR 0020000
#endif
#if defined(S_ISDIR)
#define CP_IFDIR 0040000
#endif
#if defined(S_ISREG)
#define CP_IFREG 0100000
#endif
#if defined(S_ISFIFO)
#define CP_IFIFO 0010000
#endif
#if defined(S_ISLNK)
#define CP_IFLNK 0120000
#endif
#if defined(S_ISSOCK)
#define CP_IFSOCK 0140000
#endif
#if defined(S_ISNWK)
#define CP_IFNWK 0110000
#endif

#ifndef S_ISLNK
#define lstat stat
#endif


#endif


