
#include "driosys.h"
#include "drio.h"


/*
** =========================================================================
** Global Data
** =========================================================================
*/
void (*gMainFunc) () 			= 0;

int 	glFd								= -1;
int 	glBlockSize 				= 512;
enum 	AFormatT	geFormat	= arf_unknown;

char *gInBuf							= NULL;
char *gpstrInBuf					= NULL;
long glInBufSize					= 0;
long glInSize							= 0;
long long	gllInBytes			= 0;

char *gOutBuf							= NULL;
char *gpstrOutBuf					= NULL;
long glOutBufSize					= 0;
long glOutSize						= 0;
long long	gllOutBytes			= 0;


BooleanT gbOverWriteExist	= FALSE;
BooleanT gbCreateDir			= FALSE;
BooleanT gbRetainTime			= FALSE;


/*
** =========================================================================
** Extern Data
** =========================================================================
*/
extern void ZLOG						(int, const char *, ...);
extern void MainFuncExtract	();




/*
** =========================================================================
** =========================================================================
*/
static BooleanT BufferInitialization ()
{
	BooleanT	bSuccess				= FALSE;
  int 			lTmpInBufSize		= 0;
  int 			lTmpOutBufSize	= 0;

  if (gMainFunc == MainFuncExtract)
	{
		if (glBlockSize >= 512)
		{
			lTmpInBufSize = 2 * glBlockSize;
		}
		else
		{
			lTmpInBufSize = 1024;
		}
		lTmpOutBufSize = DISK_IO_BLOCK_SIZE;
	}
  if (NULL == (gInBuf = (char *) malloc (lTmpInBufSize)))
	{
		ZLOG(0,"ERROR: Failed to allocate memory for Input Buffer in BufferInitialization");
	}
	else if (NULL == (gOutBuf = (char *) malloc (lTmpOutBufSize)))
	{
		ZLOG(0,"ERROR: Failed to allocate memory for Output Buffer in BufferInitialization");
	}
	else
	{
		gpstrInBuf 		= gInBuf;
		glInBufSize 	= lTmpInBufSize;
		glInSize 			= 0;
		gllInBytes 		= 0;

		gpstrOutBuf 	= gOutBuf;
		glOutBufSize 	= lTmpOutBufSize;
		glOutSize 		= 0;
		gllOutBytes 	= 0;

		bSuccess = TRUE;
	}
	return bSuccess;
}



/*
** =========================================================================
** ZLEM: Main
** =========================================================================
*/
extern BooleanT DrIo (char *pstrFile)
{
	BooleanT	bSuccess = FALSE;

  umask (0);
	gMainFunc = MainFuncExtract;

	if (-1 == (glFd = open (pstrFile, O_RDONLY | O_BINARY, 0666, NULL)))
	{
		ZLOG(errno,"ERROR: Failed to open input Archive: %s", pstrFile);
	}
	else if (TRUE != BufferInitialization ())
	{
		ZLOG(0,"ERROR: Failed to Initialize Buffer");
	}
	else
	{
		geFormat 					= arf_newascii;
		gbCreateDir 			= TRUE;
		gbOverWriteExist	= TRUE;
		gbRetainTime 			= TRUE;
		glBlockSize 			= 512;

		(*gMainFunc) ();

		if (-1 == close (glFd))
		{
			ZLOG(1,0,"ERROR: Failed to close input archive");
		}
		bSuccess = TRUE;
	}
	return bSuccess;
}

