static const char drloadmod_c[] = "$Header: /faststuff/CVS/dastuff190503/vaultos/unix/linux/x86/config/drloadmod.c,v 1.7 2007/01/16 17:59:42 sreenivasa Exp $";

#include <ncurses.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/mount.h>
#include <unistd.h>
#include <dirent.h>
#include <fcntl.h>
#include <net/if.h>
#include <errno.h>
#include <curses.h>
#include "drtrace.h"
#include "drmod.h"
#include "drcdrom.h"
#include "drloadmod.h"

MODULE("DRMODUTILS")

#define TRUE							1
#define FALSE							0
#define NUM_MOD_DISPLAY		15
#define	MAX_MOD_COUNT			200
#define	MAX_NUM_IF				10
#define STR_OK						"[  OK  ]"
#define STR_YES						"[  YES  ]"
#define STR_NO						"[  NO  ]"
#define STR_INSTALL				"[ Install ]" 
#define STR_OPTION				"[ Options ]" 
#define STR_OTHER					"[ Others  ]" 
#define STR_EXIT					"[   Exit  ]"
#define STR_CANCEL				"[ Cancel ]"
#define STR_BAKBONE				 "BakBone Software, Inc."
#define STR_NIC_TITLE			 "Network Interface Drivers Installation"
#define STR_NIC_TITLE_OPT	 "NIC Module Options"
#define STR_SCSI_TITLE     "SCSI Controller Drivers Installation"
#define STR_SCSI_TITLE_OPT "SCSI Module Options"

typedef unsigned char			ByteT;

static ModListT   gtAvailList [MAX_MOD_COUNT];
/* Used as an output variable*/
static ModListT  *gpLoadedModList = NULL;
static long       glNumLoadedCnt  = 0;
static long				glCount	        = 0;
static attr_t			gtAttribute[6];
static BooleanT   gbNicMenu       = FALSE;
static WINDOW     *pWin           = NULL;
/*
** =======================================================================================
** =======================================================================================
*/
static DrRequestE	DisplayRequest (
									char				*pstrYes,
									char				*pstrNo,
									char 				*pstrMsg, 
									DrRequestE 	eDefaultRequest)
{
	WINDOW		*pWin				= NULL;
	int				lX					= strlen (pstrMsg) + 10;
	int				lY					= 7;
	int				lMaxX				= 0;
	int				lMaxY				= 0;
	int				RC					= 0;
	int				i						= 0;
	int				lKeyPos			= 0;
	BooleanT	bExit				= FALSE;

	clear 		();
	refresh		();
	getmaxyx 	(stdscr, lMaxY, lMaxX);

	pWin = newwin (lY, lX, (lMaxY - lY) / 2, (lMaxX - lX) / 2);
	
	wborder (pWin, 
					ACS_VLINE 		| gtAttribute[0], 
					ACS_VLINE 		| gtAttribute[1], 
					ACS_HLINE 		| gtAttribute[0], 
					ACS_HLINE 		| gtAttribute[1], 
					ACS_ULCORNER 	| gtAttribute[0], 
					ACS_URCORNER 	| gtAttribute[0], 
					ACS_LLCORNER 	| gtAttribute[1], 
					ACS_LRCORNER 	| gtAttribute[1]);

	wattrset (pWin, gtAttribute[1]);

	for (i=1; i<lY-1; i++)
	{
		wmove 	(pWin, i, 1);
		whline 	(pWin, ' ', lX-2);
	}
	wattrset 	(pWin, gtAttribute[3]);
	mvwaddstr (pWin, 2, (lX-strlen (pstrMsg)) / 2, pstrMsg);
		
	if (DrYes == eDefaultRequest)
	{
		lKeyPos	= 0;
		wattrset 	(pWin, gtAttribute[2]);
		mvwaddstr (pWin, 4, (lX/4) - (strlen (pstrYes)/2), pstrYes);
		wattrset 	(pWin, gtAttribute[3]);
		mvwaddstr (pWin, 4, (3*lX/4) - (strlen (pstrNo)/2), pstrNo);
	}
	else
	{
		lKeyPos	= 1;
		wattrset 	(pWin, gtAttribute[3]);
		mvwaddstr (pWin, 4, (lX/4) - (strlen (pstrYes)/2), pstrYes);
		wattrset 	(pWin, gtAttribute[2]);
		mvwaddstr (pWin, 4, (3*lX/4) - (strlen (pstrNo)/2), pstrNo);
	}
	
	noecho ();
	keypad (pWin, 1);
	cbreak ();
		
	do
	{
		wrefresh 		(pWin);
		redrawwin 	(pWin);
		RC = wgetch	(pWin);

		switch (RC)
		{
			case '\t':
			case KEY_RIGHT:
			case KEY_LEFT:
			{
				if (0 == lKeyPos)
				{
					lKeyPos = 1;
					wattrset 	(pWin, gtAttribute[3]);
					mvwaddstr (pWin, 4, (lX/4) - (strlen (pstrYes)/2), pstrYes);
					wattrset 	(pWin, gtAttribute[2]);
					mvwaddstr (pWin, 4, (3*lX/4) - (strlen (pstrNo)/2), pstrNo);
				}
				else if (1 == lKeyPos)
				{
					lKeyPos = 0;
					wattrset 	(pWin, gtAttribute[2]);
					mvwaddstr (pWin, 4, (lX/4) - (strlen (pstrYes)/2), pstrYes);
					wattrset 	(pWin, gtAttribute[3]);
					mvwaddstr (pWin, 4, (3*lX/4) - (strlen (pstrNo)/2), pstrNo);
				}
				break;
			}
			
			case '\n':
			{
				bExit = TRUE;
				break;
			}
		}
	} while (TRUE != bExit);
	
	clear 	();
	refresh	();
	delwin 	(pWin);

	return lKeyPos;
}




/*
** =======================================================================================
** =======================================================================================
*/
static void WinInit ()
{
  int 		lRC 	= 0;
  int 		i 		= 0;

  pWin = initscr ();

  if (NULL != pWin)
	{
		lRC = has_colors ();

		if (0 != lRC)
		{
			start_color ();

			init_pair (1, COLOR_WHITE, 	COLOR_WHITE);
			init_pair (2, COLOR_BLACK, 	COLOR_WHITE);
			init_pair (3, COLOR_WHITE, 	COLOR_RED);
			init_pair (4, COLOR_BLUE, 	COLOR_WHITE);
			init_pair (5, COLOR_YELLOW, COLOR_BLUE);
			init_pair (6, COLOR_WHITE, 	COLOR_BLUE);

			for (i = 0; i < 6; i++)
			{
				gtAttribute[i] = COLOR_PAIR (i + 1) | ((!(i & 1)) ? A_BOLD : 0);
			}
		}
		else
		{
			gtAttribute[0] = gtAttribute[1] = gtAttribute[3] =
			gtAttribute[4] = gtAttribute[5] = A_NORMAL;
			gtAttribute[2] = A_REVERSE;
		}
	}
}



/*
** =======================================================================================
** =======================================================================================
*/
static void DisplayInfo (char *pstrMsg)
{
	WINDOW		*pWin				= NULL;
	int				lX					= strlen (pstrMsg) + 10;
	int				lY					= 5;
	int				lMaxX				= 0;
	int				lMaxY				= 0;
	int				i						= 0;

	clear 		();
	refresh		();
	getmaxyx 	(stdscr, lMaxY, lMaxX);

	pWin = newwin (lY, lX, (lMaxY - lY) / 2, (lMaxX - lX) / 2);
	
	wborder (pWin, 
					ACS_VLINE 		| gtAttribute[0], 
					ACS_VLINE 		| gtAttribute[1], 
					ACS_HLINE 		| gtAttribute[0], 
					ACS_HLINE 		| gtAttribute[1], 
					ACS_ULCORNER 	| gtAttribute[0], 
					ACS_URCORNER 	| gtAttribute[0], 
					ACS_LLCORNER 	| gtAttribute[1], 
					ACS_LRCORNER 	| gtAttribute[1]);

	wattrset (pWin, gtAttribute[1]);

	for (i=1; i<lY-1; i++)
	{
		wmove 	(pWin, i, 1);
		whline 	(pWin, ' ', lX-2);
	}
	wattrset 	(pWin, gtAttribute[3]);
	mvwaddstr (pWin, 2, (lX-strlen (pstrMsg)) / 2, pstrMsg);
	wrefresh	(pWin);
	redrawwin (pWin);
}




/*
** =======================================================================================
** =======================================================================================
*/
static void DisplayMsg (char *pstrMsg)
{
	WINDOW		*pWin				= NULL;
	int				lLen				= strlen (pstrMsg);
	int				lX					= lLen + 4;
	int				lY					= 7;
	int				lMaxX				= 0;
	int				lMaxY				= 0;
	int				RC					= 0;
	int				i						= 0;

	clear 		();
	refresh		();
	getmaxyx 	(stdscr, lMaxY, lMaxX);

	if (lX > lMaxX)
	{
		lX = lLen = lMaxX - 4;
	}
	pWin = newwin (lY, lX, (lMaxY - lY) / 2, (lMaxX - lX) / 2);
	
	wborder (pWin, 
					ACS_VLINE 		| gtAttribute[0], 
					ACS_VLINE 		| gtAttribute[1], 
					ACS_HLINE 		| gtAttribute[0], 
					ACS_HLINE 		| gtAttribute[1], 
					ACS_ULCORNER 	| gtAttribute[0], 
					ACS_URCORNER 	| gtAttribute[0], 
					ACS_LLCORNER 	| gtAttribute[1], 
					ACS_LRCORNER 	| gtAttribute[1]);

	wattrset (pWin, gtAttribute[1]);

	for (i=1; i<lY-1; i++)
	{
		wmove 	(pWin, i, 1);
		whline 	(pWin, ' ', lX-2);
	}
	wattrset 	(pWin, gtAttribute[3]);
	mvwaddstr (pWin, 2, (lX-lLen) / 2, pstrMsg);
	wattrset 	(pWin, gtAttribute[2]);
	mvwaddstr (pWin, 4, (lX-strlen (STR_OK)) /2, STR_OK);
		
	do
	{
		RC = wgetch	(pWin);
	} while (RC != '\n');
	
	clear 	();
	refresh	();
	delwin 	(pWin);
}





/*
** =======================================================================================
** =======================================================================================
*/
static char *Strip0x20 (char *pstr)
{
	int  i;

	for (i=strlen(pstr)-1; i>0; i--)
	{
		if (0x20 != pstr[i])
		{
			break;
		}
		else if (0x20 == pstr[i])
		{
			pstr[i] = 0;
		}
	}
	while (0 != *pstr)
	{
		if (0x20 != *pstr)
		{
			break;
		}
		pstr++;
	}
	return pstr;
}





/*
** =======================================================================================
** =======================================================================================
*/
static BooleanT ParseModTxtFile (char *pstrFile, BooleanT bNicMods)
{
	BooleanT 	bSuccess 	= TRUE;
	FILE 			*pFd 			= fopen (pstrFile, "r");

	TRACE(("Parse and Load device drivers file: %s", pstrFile));

	if (NULL == pFd)
	{
		TRACE(("ERROR: Failed to open file: %s. %s", pstrFile, strerror(errno)));
	}
	else
	{
		long			lFlag			= 0;
		long			lCount		= 0;
		char 			*pstr1		= NULL;
		char 			*pstr2 		= NULL;
		char			strBuf[128];

		while (NULL != fgets  (strBuf, sizeof (strBuf), pFd) && 
					 NULL != strchr (strBuf, 0x3b) && TRUE == bSuccess)
		{
			pstr1 = pstr2 = strBuf;
					
			while (0 != *pstr2++)
			{
				if (0x09 == *pstr2)
				{
					*pstr2 = 0x20;
				}
				else if (0x0d == *pstr2 || 0x0a == *pstr2)
				{
					*pstr2 = 0;
				}
			}
			lFlag	= lCount = 0;
			pstr1 = pstr2  = strBuf;

			while (0 != *pstr2)
			{
				if (0x3b == *pstr2 && 0 == lFlag)
				{
					*pstr2 = 0;
					pstr1	 = Strip0x20 (pstr1);
					lFlag++;

					if (NULL == (gtAvailList[glCount].pstrComp = (char *) malloc (strlen (pstr1) + 1)))
					{
						TRACE(("ERROR: Failed to allocate memory-1"));
						bSuccess = FALSE;
					}
					else
					{
						strncpy (gtAvailList[glCount].pstrComp, pstr1, strlen (pstr1) + 1);
					}
					pstr1 = pstr2 + 1;
				}
				else if (0x3b == *pstr2 && 1 == lFlag)
				{
					*pstr2 = 0;
					pstr1  = Strip0x20 (pstr1);
					lFlag++;

					if (NULL == (gtAvailList[glCount].pstrDesc = (char *) malloc (strlen (pstr1) + 1)))
					{
						TRACE(("ERROR: Failed to allocate memory-2"));
						bSuccess = FALSE;
					}
					else
					{
						strncpy (gtAvailList[glCount].pstrDesc, pstr1, strlen (pstr1) + 1);
					}
					pstr1 = pstr2 + 1;
				}
				else if (0x3b == *pstr2 && 1 < lFlag)
				{
					*pstr2 = 0;
					pstr1  = Strip0x20 (pstr1);
			
					if (NULL == (gtAvailList[glCount].pstrMods[lCount] = (char *) malloc (strlen (pstr1) + 1)))
					{
						TRACE(("ERROR: Failed to allocate memory-3"));
						bSuccess = FALSE;
					}
					else
					{
						strncpy (gtAvailList[glCount].pstrMods[lCount++], pstr1, strlen (pstr1) + 1);
						gtAvailList[glCount].lModCount = lCount;
					}
					pstr1 = pstr2 + 1;
				}
				pstr2++;
			}

			if (0 != pstr1)
			{
				pstr1 = Strip0x20 (pstr1);

				if (NULL == (gtAvailList[glCount].pstrMods[lCount] = (char *) malloc (strlen (pstr1) + 1)))
				{
					TRACE(("ERROR: Failed to allocate memory-4"));
					bSuccess = FALSE;
				}
				else
				{
					strncpy (gtAvailList[glCount].pstrMods[lCount++], pstr1, strlen (pstr1) + 1);
					gtAvailList[glCount].lModCount = lCount;
				}
			}
			gtAvailList[glCount].bModNet = bNicMods; /* Flag this modules as NIC or SCSI*/
			glCount++;
		}
		fclose (pFd);
	}
	TRACE(("End Parse and Load device drivers file. %s",
	bSuccess ? "SUCCESS" : "ERROR"));

	return bSuccess;
}





/*
** =======================================================================================
** =======================================================================================
*/
static BooleanT GetModuleOption (char *pstrOpt, int lOptSize)
{
	WINDOW		*pWin				= NULL;
	int				lX					= 78;
	int				lY					= 8;
	int				lMaxX				= 0;
	int				lMaxY				= 0;
	int				i						= 0;
	int				lPos				= 0;
	int				lCursePos		= 0;
	int				lTagLen			= strlen ("Options: ");
	int				lParmLen		= (lX - lTagLen) - 4;
	int				lParmStart	= lTagLen + 2;
	int				lInput			= 0;
	BooleanT	bContinue		= TRUE;
	BooleanT	bSuccess		= FALSE;

	clear 	 ();
	refresh	 ();
	getmaxyx (stdscr, lMaxY, lMaxX);

	pWin = newwin (lY, lX, (lMaxY - lY) / 2, (lMaxX - lX) / 2);

	wborder (pWin, 
					ACS_VLINE 		| gtAttribute[0], 
					ACS_VLINE 		| gtAttribute[1], 
					ACS_HLINE 		| gtAttribute[0], 
					ACS_HLINE 		| gtAttribute[1], 
					ACS_ULCORNER 	| gtAttribute[0], 
					ACS_URCORNER 	| gtAttribute[0], 
					ACS_LLCORNER 	| gtAttribute[1], 
					ACS_LRCORNER 	| gtAttribute[1]);

	wattrset (pWin, gtAttribute[1]);

	for (i=1; i<lY-1; i++)
	{
		wmove 	(pWin, i, 1);
		whline 	(pWin, ' ', lX-2);
	}
	wattrset 	(pWin, gtAttribute[3]);
	if (TRUE == gbNicMenu)
	{
		mvwaddstr (pWin, 1, (lX/2) - (strlen (STR_NIC_TITLE_OPT) / 2), STR_NIC_TITLE_OPT);
	}
	else
	{
		mvwaddstr (pWin, 1, (lX/2) - (strlen (STR_SCSI_TITLE_OPT) / 2), STR_SCSI_TITLE_OPT);
	}
	wattrset 	(pWin, gtAttribute[1]);
	wmove 		(pWin, 2, 1);
	whline 		(pWin, ACS_HLINE, lX-2);
	
	wattrset 	(pWin, gtAttribute [1]);
	mvwaddstr (pWin, 3, 2, "Options: ");
	wattrset 	(pWin, gtAttribute[5]);
	whline 		(pWin, ' ', lParmLen);
	memset    (pstrOpt, 0, lParmLen);

	wattrset 	(pWin, gtAttribute[1]);
	wmove 		(pWin, lY-3, 1);
	whline 		(pWin, ACS_HLINE, lX-2);
	wattrset 	(pWin, gtAttribute[3]);
	mvwaddstr (pWin, lY-2, (lX/4) - (strlen (STR_INSTALL)/2), STR_INSTALL);
	mvwaddstr (pWin, lY-2, (3*lX/4) - (strlen (STR_CANCEL)/2), STR_CANCEL);
	
	wrefresh	(pWin);
	noecho 		();
	keypad 		(pWin, 1);
	cbreak 		();
	
	while (TRUE == bContinue)
	{
		if (lPos < 1)
		{
			wattrset 	(pWin, gtAttribute[3]);
			mvwaddstr (pWin, lY-2, (3*lX/4) - (strlen (STR_CANCEL)/2), STR_CANCEL);
			mvwaddstr (pWin, lY-2, (lX/4) - (strlen (STR_INSTALL)/2), STR_INSTALL);

			wmove 		(pWin, 3, lParmStart);
			wattrset 	(pWin, gtAttribute[4]);
			whline 		(pWin, ' ', lParmLen);
			waddstr 	(pWin, pstrOpt);
			wmove 		(pWin, 3, lParmStart + lCursePos);

			lInput = wgetch (pWin);

			wmove 		(pWin, 3, lParmStart);
			wattrset 	(pWin, gtAttribute[5]);
			whline 		(pWin, ' ', lParmLen);
			waddstr 	(pWin, pstrOpt);

			switch (lInput)
			{
				case KEY_LEFT:
				{
					if (lCursePos > 0)
					{
						lCursePos--;
					}
					break;
				}
				
				case KEY_RIGHT:
				{
					if (lCursePos < strlen (pstrOpt))
					{
						lCursePos++;
					}
					break;
				}

				case KEY_HOME:
				{
					lCursePos = 0;
					break;
				}
				
				case KEY_END:
				{
					lCursePos = strlen (pstrOpt);
					break;
				}
				
				case KEY_BACKSPACE:
				{
					if (lCursePos > 0)
					{
						lCursePos--;
						memmove	(
								pstrOpt + lCursePos, 
								pstrOpt + lCursePos + 1, 
								strlen (pstrOpt) - lCursePos);
					}
					break;
				}
				
				case KEY_DC:
				{
					if (lCursePos < strlen (pstrOpt))
					{
						memmove (
								pstrOpt + lCursePos, 
								pstrOpt + lCursePos + 1, 
								strlen (pstrOpt) - lCursePos);
					}
					break;
				}
				
				case '\n':
				{
					lInput = KEY_DOWN;
					break;
				}

				case ' '...'~':
				{
					/*
					if (strlen (pstrOpt) < lMaxX - lTagLen - 6)
					{
						memmove (
								pstrOpt + lCursePos + 1, 
								pstrOpt + lCursePos, 
								strlen (pstrOpt) - lCursePos + 1);

						pstrOpt[lCursePos++] = lInput;
					}
					*/

					if (strlen (pstrOpt) < lOptSize)
					{
						memmove (
								pstrOpt + lCursePos + 1, 
								pstrOpt + lCursePos, 
								strlen (pstrOpt) - lCursePos + 1);

						pstrOpt[lCursePos++] = lInput;
					}

					break;
				}
			}
		}
		else
		{
			if (1 == lPos)
			{
				wattrset 	(pWin, gtAttribute[3]);
				mvwaddstr (pWin, lY-2, (3*lX/4) - (strlen (STR_CANCEL)/2), STR_CANCEL);
				wattrset 	(pWin, gtAttribute[2]);
				mvwaddstr (pWin, lY-2, (lX/4) - (strlen (STR_INSTALL)/2), STR_INSTALL);
			}
			else if (2 == lPos)
			{
				wattrset 	(pWin, gtAttribute[3]);
				mvwaddstr (pWin, lY-2, (lX/4) - (strlen (STR_INSTALL)/2), STR_INSTALL);
				wattrset 	(pWin, gtAttribute[2]);
				mvwaddstr (pWin, lY-2, (3*lX/4) - (strlen (STR_CANCEL)/2), STR_CANCEL);
			}
			lInput = wgetch (pWin);
		}

		switch (lInput)
		{
			case '\t':
			case KEY_DOWN:
			{
				lCursePos = 0;
				lPos++;
				lPos %= 3;
				break;
			}

			case KEY_UP:
			{
				lCursePos = 0;

				if (--lPos < 0)
				{
					lPos = 2;
				}
				break;
			}
				
			case '\n':
			{
				if (1 == lPos)
				{
					bSuccess = TRUE;
				}
				bContinue = FALSE;
				break;
			}
		}
	}
	delwin		(pWin);
	redrawwin	(stdscr);
	refresh		();

	return bSuccess;
}




/*
** =======================================================================================
** =======================================================================================
*/
static void LoadOthers (
						WINDOW 	*pWin, 
						long		lCount,
						char 		**ppstr)
{
	int		lInitY	= 4;
	int		lInitX	= 4;
	int		i 			= 1;

	wattrset (pWin, gtAttribute [1]);

	for (i=1; i<=lCount; i++)
	{
		wmove 		(pWin, i+lInitY, lInitX);
		whline 		(pWin, ' ', 50-lInitX*2);
		mvwaddstr (pWin, i+lInitY, lInitX, ppstr [i-1]);
	}
}


/*
** =======================================================================================
** =======================================================================================
*/
static void DisplayMenuOthers (
						WINDOW 		*pWin,
						long 			lCount,
						char 			**ppstr,
						int				lX,
						int				lY)
{
	int				lInitY			= 4;
	int				lInitX			= 4;
	int				lMaxX				= 0;
	int				lMaxY				= 0;
	int				lPos				= 1;
	int				lIdx				= 1;
	int				lSec				= lX/3;
	int				RC					= 0;
	int				lKeyPos			= 1;
	BooleanT	bExit				= FALSE;
		
	getmaxyx 		(pWin, lMaxY, lMaxX);
	LoadOthers 	(pWin, lCount, ppstr);
	noecho 			();
	keypad 			(pWin, 1);
	cbreak 			();
		
	do
	{
		wattrset 		(pWin, gtAttribute [2]);
		wmove 			(pWin, lPos+lInitY, 2);
		whline 			(pWin, ' ', lMaxX - 4);
		mvwaddstr 	(pWin, lPos+lInitY, lInitX, ppstr [lIdx-1]);
		whline			(pWin, ' ',(lInitX - strlen (ppstr [lIdx-1])+1) / 2 - 2);
		wrefresh 		(pWin);
		redrawwin 	(pWin);
		RC = wgetch	(pWin);
		wattrset 		(pWin, gtAttribute [1]);
		wmove 			(pWin, lPos+lInitY, 2);
		whline 			(pWin, ' ', lMaxX - 4);
		mvwaddstr 	(pWin, lPos+lInitY, lInitX, ppstr [lIdx-1]);

		switch (RC)
		{
			case KEY_UP:
			{
				if (1 < lPos)
				{
					lPos--;
				}
				if (1 < lIdx)
				{
					lIdx--;
				}
				break;
			}

			case KEY_DOWN:
			{
				if (lCount > lPos)
				{
					lPos++;
				}
				if (lCount > lIdx)
				{
					lIdx++;
				}
				break;
			}
  
			case '\t':
			case KEY_RIGHT:
			{
				if (1 == lKeyPos)
				{
					lKeyPos++;

					wattrset 	(pWin, gtAttribute[2]);
					wmove 		(pWin, lY-2, 0*lSec + (lSec - strlen (STR_INSTALL))/2);
					whline 		(pWin, ' ', strlen (STR_INSTALL));
					mvwaddstr (pWin, lY-2, 0*lSec + (lSec - strlen (STR_INSTALL))/2, 	STR_INSTALL);
				}
				else if (2 == lKeyPos)
				{
					lKeyPos++;

					wattrset 	(pWin, gtAttribute[3]);
					wmove 		(pWin, lY-2, 0*lSec + (lSec - strlen (STR_INSTALL))/2);
					whline 		(pWin, ' ', strlen (STR_INSTALL));
					mvwaddstr (pWin, lY-2, 0*lSec + (lSec - strlen (STR_INSTALL))/2, 	STR_INSTALL);
					
					wattrset 	(pWin, gtAttribute[2]);
					wmove 		(pWin, lY-2, 1*lSec + (lSec - strlen (STR_OPTION))/2);
					whline 		(pWin, ' ', strlen (STR_OPTION));
					mvwaddstr (pWin, lY-2, 1*lSec + (lSec - strlen (STR_OPTION))/2, STR_OPTION);
				}
				else if (3 == lKeyPos)
				{
					lKeyPos++;

					wattrset 	(pWin, gtAttribute[3]);
					wmove 		(pWin, lY-2, 1*lSec + (lSec - strlen (STR_OPTION))/2);
					whline 		(pWin, ' ', strlen (STR_OPTION));
					mvwaddstr (pWin, lY-2, 1*lSec + (lSec - strlen (STR_OPTION))/2, STR_OPTION);

					wattrset 	(pWin, gtAttribute[2]);
					wmove 		(pWin, lY-2, 2*lSec + (lSec - strlen (STR_EXIT))/2);
					whline 		(pWin, ' ', strlen (STR_EXIT));
					mvwaddstr (pWin, lY-2, 2*lSec + (lSec - strlen (STR_EXIT))/2, STR_EXIT);
				}
				else
				{
					lKeyPos = 1;

					wattrset 	(pWin, gtAttribute[3]);
					wmove 		(pWin, lY-2, 2*lSec + (lSec - strlen (STR_EXIT))/2);
					whline 		(pWin, ' ', strlen (STR_EXIT));
					mvwaddstr (pWin, lY-2, 2*lSec + (lSec - strlen (STR_EXIT))/2, STR_EXIT);
				}
				break;
			}
			
			case KEY_LEFT:
			{
				if (1 == lKeyPos)
				{
					lKeyPos	= 4;

					wattrset 	(pWin, gtAttribute[2]);
					wmove 		(pWin, lY-2, 2*lSec + (lSec - strlen (STR_EXIT))/2);
					whline 		(pWin, ' ', strlen (STR_EXIT));
					mvwaddstr (pWin, lY-2, 2*lSec + (lSec - strlen (STR_EXIT))/2, STR_EXIT);
				}
				else if (4 == lKeyPos)
				{
					lKeyPos--;

					wattrset 	(pWin, gtAttribute[3]);
					wmove 		(pWin, lY-2, 2*lSec + (lSec - strlen (STR_EXIT))/2);
					whline 		(pWin, ' ', strlen (STR_EXIT));
					mvwaddstr (pWin, lY-2, 2*lSec + (lSec - strlen (STR_EXIT))/2, STR_EXIT);

					wattrset 	(pWin, gtAttribute[2]);
					wmove 		(pWin, lY-2, 1*lSec + (lSec - strlen (STR_OPTION))/2);
					whline 		(pWin, ' ', strlen (STR_OPTION));
					mvwaddstr (pWin, lY-2, 1*lSec + (lSec - strlen (STR_OPTION))/2, STR_OPTION);
				}
				else if (3 == lKeyPos)
				{
					lKeyPos--;

					wattrset 	(pWin, gtAttribute[3]);
					wmove 		(pWin, lY-2, 1*lSec + (lSec - strlen (STR_OPTION))/2);
					whline 		(pWin, ' ', strlen (STR_OPTION));
					mvwaddstr (pWin, lY-2, 1*lSec + (lSec - strlen (STR_OPTION))/2, STR_OPTION);

					wattrset 	(pWin, gtAttribute[2]);
					wmove 		(pWin, lY-2, 0*lSec + (lSec - strlen (STR_INSTALL))/2);
					whline 		(pWin, ' ', strlen (STR_INSTALL));
					mvwaddstr (pWin, lY-2, 0*lSec + (lSec - strlen (STR_INSTALL))/2, 	STR_INSTALL);
				}
				else if (2 == lKeyPos)
				{
					lKeyPos--;
					
					wattrset 	(pWin, gtAttribute[3]);
					wmove 		(pWin, lY-2, 0*lSec + (lSec - strlen (STR_INSTALL))/2);
					whline 		(pWin, ' ', strlen (STR_INSTALL));
					mvwaddstr (pWin, lY-2, 0*lSec + (lSec - strlen (STR_INSTALL))/2, 	STR_INSTALL);
				}
				break;
			}

			case '\n':
			{
				if (4 == lKeyPos)
				{
					bExit = TRUE;
				}
				else if (3 == lKeyPos)
				{
					char strOpt[512] = {0};
					char *pstrOpt		 = NULL;

					memset (strOpt, 0, sizeof (strOpt));

					if (TRUE == GetModuleOption (strOpt, sizeof (strOpt)))
					{
						if (0 == strlen ((pstrOpt = Strip0x20 (strOpt))))
						{
							DisplayMsg("ERROR: Module options is blank");
						}
						else
						{
							BooleanT	bSuccess		= TRUE;
							char			strCmd[600] = {0};
							char			strMsg[128] = {0};

							TRACE(("Begin load other module with option. Mod: /mp/%s  Option: %s",
							ppstr[lIdx-1], pstrOpt));

							memset (strMsg, 0, sizeof (strMsg));
							memset (strCmd, 0, sizeof (strCmd));
							sprintf(strCmd,"/bin/insmod -f  /mp/%s %s >> /trace/dr.log 2>&1", 
							ppstr[lIdx-1], pstrOpt);
	
							DisplayInfo("Loading module. Please wait...");
							sleep(1);

							if (0 != system (strCmd))
							{
								snprintf(strMsg,128, "Failed to load Mod: /mp/%s Opt:%s",
								ppstr[lIdx-1], pstrOpt);
								bSuccess = FALSE;
							}
							else
							{
								snprintf(strMsg,128, "Successful load Mod: /mp/%s Opt: %s",
								ppstr[lIdx-1], pstrOpt);
							}
							TRACE(("End load other module with option. Mod: /mp/%s  Option: %s (%s)",
							ppstr[lIdx-1], pstrOpt, bSuccess ? "TRUE" : "FALSE"));
							
							DisplayMsg (strMsg);
						}
					}
				}
				else if (2 == lKeyPos || 1 == lKeyPos)
				{
					char strModFile[128] 	= {0};
					char strMsg[128] 			= {0};
					int	 lRC = 0;

					memset	(strMsg, 0, sizeof (strMsg));
					memset	(strModFile, 0, sizeof (strModFile));
					snprintf(strModFile, 128,"/mp/%s", ppstr[lIdx-1]);

					TRACE(("Begin loading other module: %s", strModFile));
					DisplayInfo("Loading module. Please wait...");
					sleep(1);

					if (TRUE != DrCmdLoadModule (strModFile, &lRC) && lRC == DRMOD_ERR_FATAL)
					{
						snprintf(strMsg,128, "ERROR: Failed to load module: %s",ppstr[lIdx-1]);
						DisplayMsg (strMsg);
					}
					else if (lRC == DRMOD_ERR_EXIST)
					{
						snprintf(strMsg,128, "WARN: Module already loaded: %s",ppstr[lIdx-1]);
						DisplayMsg (strMsg);
					}
					else if (lRC == DRMOD_ERR_NONE)
					{
						snprintf(strMsg,128, "Load module successfully: %s",ppstr[lIdx-1]);
						DisplayMsg (strMsg);
					}
					TRACE(("End loading other module: %s", strModFile));
				}
				break;
			}
		}
	} while (TRUE != bExit);
}





/*
** =======================================================================================
** =======================================================================================
*/
static void DisplayOthers (long lCount, char **ppstr)
{
  WINDOW  *pWin     = NULL;
  int     lX        = 51;
  int     lY        = 19;
  int     lMaxX     = 0;
  int     lMaxY     = 0;
	int			lSec			= lX/3;
  int     i         = 0;

  getmaxyx (stdscr, lMaxY, lMaxX);

  pWin = newwin (lY, lX, (lMaxY - lY) / 2, (lMaxX - lX) / 2);

  wborder (pWin,
          ACS_VLINE     | gtAttribute[0],
          ACS_VLINE     | gtAttribute[1],
          ACS_HLINE     | gtAttribute[0],
          ACS_HLINE     | gtAttribute[1],
          ACS_ULCORNER  | gtAttribute[0],
          ACS_URCORNER  | gtAttribute[0],
          ACS_LLCORNER  | gtAttribute[1],
          ACS_LRCORNER  | gtAttribute[1]);

  wattrset (pWin, gtAttribute[1]);

  for (i=1; i<lY-1; i++)
  {
    wmove   (pWin, i, 1);
    whline  (pWin, ' ', lX-2);
  }
  wattrset  (pWin, gtAttribute[3]);
  mvwaddstr (pWin, 1, (lX-strlen (STR_BAKBONE)) / 2, STR_BAKBONE);
	if (TRUE == gbNicMenu)
	{
		mvwaddstr (pWin, 2, (lX-strlen (STR_NIC_TITLE)) / 2, STR_NIC_TITLE);
	}
	else
	{
		mvwaddstr (pWin, 2, (lX-strlen (STR_SCSI_TITLE)) / 2, STR_SCSI_TITLE);
	}
  wattrset  (pWin, gtAttribute[1]);
  wmove     (pWin, 3, 1);
  whline    (pWin, ACS_HLINE, lX-2);
  wmove     (pWin, lY-3, 1);
  whline    (pWin, ACS_HLINE, lX-2);

  wattrset  (pWin, gtAttribute[3]);

  mvwaddstr (pWin, lY-2, 0*lSec + (lSec - strlen (STR_INSTALL))/2, 	STR_INSTALL);
  mvwaddstr (pWin, lY-2, 1*lSec + (lSec - strlen (STR_OPTION))/2, 	STR_OPTION);
  mvwaddstr (pWin, lY-2, 2*lSec + (lSec - strlen (STR_EXIT))/2, 		STR_EXIT);

  DisplayMenuOthers (pWin, lCount, ppstr, lX, lY);

  delwin    (pWin);
  redrawwin (stdscr);
  refresh   ();

}



/*
** =======================================================================================
** =======================================================================================
*/
static void GetAvailOthers ()
{
	BooleanT	bSuccess			= FALSE;
	char 			pstrUsbDev[]	= "/dev/sd ";
	DIR				*pDir					= NULL;
	BooleanT  bLoadCDROM    = FALSE;
	char      strMediaMsg[256] = "Insert disk with drivers into floppy drive";

	TRACE(("Begin GetAvailOthers"));

	if (DrYes ==	DisplayRequest (
								"CDROM", 
								"FLOPPY", 
								"Choose the media for loading the drivers", 
								DrNo))
	{
		bLoadCDROM = TRUE;
		snprintf(strMediaMsg, 256, "Insert disk with drivers into cdrom drive");
	}
	
	if (DrYes == DisplayRequest(STR_OK, STR_CANCEL, strMediaMsg, DrYes))
	{
		DrcdromE eCdromRC = DRCDROM_NOT_FOUND;
		umount ("/mp");
		umount ("/dev/fd0");

		if (TRUE == bLoadCDROM && 
			  DRCDROM_MOUNTED != (eCdromRC = LocateAndMountCDROM()))
		{
			if (DRCDROM_NOT_FOUND == eCdromRC)
				DisplayMsg("ERROR: Failed to find any IDE/SCSI/USB CDROMs");
			else 
				DisplayMsg("ERROR: Failed to mount the CDROM, check that the disk is valid");
		}
		else if (FALSE == bLoadCDROM &&
			       -1 == mount ("/dev/fd0", "/mp", "msdos", MS_RDONLY, NULL))
		{
			BooleanT	bContinue	= TRUE;
			long			i;

			TRACE(("WARN: Failed to mount /dev/fd0. Will try to mount Usb Device"));

			for (i=0; i<8 && TRUE == bContinue; i++)
			{
				pstrUsbDev[7] = 0x61 + i;
		
				umount ("/mp");
				umount (pstrUsbDev);

				if (-1 != mount (pstrUsbDev, "/mp", "msdos", MS_RDONLY, NULL))
				{
					bSuccess 	= TRUE;
					bContinue	= FALSE;
				}
				else
				{
					TRACE(("WARN: Failed to mount Usb device: %s", pstrUsbDev));
				}
			}
		}
		else
		{
			bSuccess = TRUE;
		}

		if (FALSE == bSuccess && TRUE == bLoadCDROM)
		{
			TRACE(("ERROR: Failed to mount cdrom onto /mp"));
		}
		else if (FALSE == bSuccess && FALSE == bLoadCDROM)
		{
			DisplayMsg("ERROR: Failed to mount floppy. Verify floppy disk");
		}
		else if (NULL == (pDir = opendir ("/mp")))
		{
			DisplayMsg("ERROR: Failed to opendir /mp mount point");
		}
		else
		{
			struct		dirent	*pDirEnt	= NULL;
			BooleanT	bContinue					= TRUE;
			long			lCount						= 0;
			char			*pstrBuf					= (char *) malloc (512);
			char			*pstrArg[10];

			bSuccess = FALSE;

			if (NULL == pstrBuf)
			{
				DisplayMsg("Failed to allocate memory");
			}
			else
			{
				memset (pstrBuf, 0, 512);

				while (TRUE == bContinue && lCount < 10)
				{
					if (NULL == (pDirEnt = readdir (pDir)))
					{
						TRACE(("WARN: Failed to readdir"));
						bContinue = FALSE;
					}
					else
					{
						if (0 != strcmp (pDirEnt->d_name, ".") 	&&
								0 != strcmp (pDirEnt->d_name, "..") &&
								0 != strstr (pDirEnt->d_name, DR_MOD_EXT))
						{
							TRACE(("Found device drivers: %s", pDirEnt->d_name));

							strncpy (pstrBuf, pDirEnt->d_name, strlen (pDirEnt->d_name));
							pstrArg[lCount++] = pstrBuf;
							pstrBuf += strlen (pDirEnt->d_name) + 1;
							bSuccess = TRUE;
						}
					}
				}

				if (TRUE != bSuccess)
				{
					DisplayMsg("Disk does not contain any drivers (*.o)");
				}
				else
				{
					DisplayOthers (lCount, pstrArg);
				}
				free (pstrArg[0]);
			}
			closedir (pDir);
		}
		umount ("/mp");
		umount ("/dev/fd0");
		umount ("/dev/cdrom");
		umount (pstrUsbDev);
	}
	TRACE(("End GetAvailOthers (%s)", bSuccess ? "TRUE" : "FALSE"));
}


/*
** =======================================================================================
** Function keeps track of which modules we have tried to load, so we
** report it back to the main drprobe GUI.
** =======================================================================================
*/
static BooleanT UpdateLoadedList (ModListT *pModItem, long lRC)
{
	BooleanT bSuccess = FALSE;
	int      i        = 0;
	
	TRACE(("Adding Attempt to Load %s to reporting array", pModItem->pstrDesc)); 
	if (NULL == gpLoadedModList)
	{
		TRACE(("WARNING: NULL reporting list 'gpLoadedModList'"));
	}
	else
	{
		BooleanT bFoundEntry = FALSE;
		/* Ensure that we don't duplicate entries in the array. */
		for (i = 0; i < glNumLoadedCnt; i++)
		{
			if (0 == strcmp(pModItem->pstrDesc, gpLoadedModList[i].pstrDesc))
			{
				TRACE(("Entry Already exists")); 
				bFoundEntry = TRUE;
			}
		}
		if (FALSE == bFoundEntry)
		{
			TRACE(("Adding New Entry into List")); 
			/* Keep track of which mods you tried to load already for reporting purposes */
			gpLoadedModList[glNumLoadedCnt].pstrDesc  = (char*) malloc( strlen(pModItem->pstrDesc) + 1);
			snprintf(gpLoadedModList[glNumLoadedCnt].pstrDesc, strlen(pModItem->pstrDesc)+1, pModItem->pstrDesc);
			gpLoadedModList[glNumLoadedCnt].pstrComp  = (char*) malloc( strlen(pModItem->pstrComp) + 1);
			snprintf(gpLoadedModList[glNumLoadedCnt].pstrComp, strlen(pModItem->pstrComp)+1, pModItem->pstrComp);
			gpLoadedModList[glNumLoadedCnt].lModCount = pModItem->lModCount;
			gpLoadedModList[glNumLoadedCnt].bModNet   = pModItem->bModNet;

			for (i=0; i<pModItem->lModCount; i++)
			{
				gpLoadedModList[glNumLoadedCnt].pstrMods[i] = (char*) malloc( strlen(pModItem->pstrMods[i]) + 1);
				snprintf(gpLoadedModList[glNumLoadedCnt].pstrMods[i], strlen(pModItem->pstrMods[i])+1, pModItem->pstrMods[i]);
			}		
			gpLoadedModList[glNumLoadedCnt].lRC = lRC;
			glNumLoadedCnt++;
		}
		bSuccess = TRUE;
	}
	return bSuccess;
}

/*
** =======================================================================================
** =======================================================================================
*/
static BooleanT InstallMods (long lIdx, int *plRC)
{
	BooleanT	bSuccess	= TRUE;
	int				i					= 0;
	int				lRC				= 0;
	char			strModFile[64];

	for (i=0; i<gtAvailList[lIdx].lModCount && TRUE == bSuccess; i++)
	{
		memset (strModFile, 0, sizeof (strModFile));
		if (TRUE == gbNicMenu)
		{
			snprintf(strModFile, 64, "%s", gtAvailList[lIdx].pstrMods[i]);
		}
		else
		{
			snprintf(strModFile, 64, "%s", gtAvailList[lIdx].pstrMods[i]);
		}
		DisplayInfo("Loading module. Please wait...");
		sleep(1);
					
		if (TRUE != DrCmdLoadModule (strModFile, &lRC))
		{
			TRACE(("ERROR: Failed to load Module: %s", strModFile));
			bSuccess = FALSE;
		}
		else
		{
			TRACE(("Install module successful: %s", strModFile));
		}
	}
	*plRC = lRC;
	/* Show that we tried to load this module*/
	UpdateLoadedList(&gtAvailList[lIdx], lRC);
	
	return bSuccess;
}






/*
** =======================================================================================
** =======================================================================================
*/
static void LoadModMenu (WINDOW *pWin, int lOffset, int lX, int lY)
{
	int		lInitY			= 4;
	int		lInitX			= 4;
	int		i 					= 1;
	char	strBuf[128] = {0};

	wattrset (pWin, gtAttribute [1]);

	for (i=1; i<=NUM_MOD_DISPLAY; i++)
	{
		wmove 		(pWin, i+lInitY, lInitX);
		whline 		(pWin, ' ', lX-lInitX*2);
		memset    (strBuf, 0, sizeof (strBuf));
		snprintf	(strBuf, 128, "%-10s %s", gtAvailList[i+lOffset-1].pstrComp, gtAvailList[i+lOffset-1].pstrDesc);
		mvwaddstr (pWin, i+lInitY, lInitX, strBuf);
	}
}




/*
** =======================================================================================
** =======================================================================================
*/
static void DisplayModMenu (WINDOW *pWin, int lX, int lY) 
{
	int				lInitY			= 4;
	int				lInitX			= 4;
	int				lMaxX				= 0;
	int				lMaxY				= 0;
	int				lPos				= 1;
	int				lIdx				= 1;
	int				lRC					= 0;
	int				lSec				= lX/4;
	int				lOffset			= glCount - NUM_MOD_DISPLAY;
	int				lKeyPos			= 1;
	BooleanT	bExit				= FALSE;
	char			strBuf[128] = {0};

	getmaxyx 		(pWin, lMaxY, lMaxX);
	LoadModMenu	(pWin, glCount - NUM_MOD_DISPLAY - lOffset, lX, lY);
	noecho 			();
	keypad 			(pWin, 1);
	cbreak 			();

	do
	{
		memset      (strBuf, 0, sizeof (strBuf));
		snprintf     (strBuf, 128, "%-10s %s", gtAvailList[lIdx-1].pstrComp, gtAvailList[lIdx-1].pstrDesc);
		wattrset 		(pWin, gtAttribute [2]);
		wmove 			(pWin, lPos+lInitY, 2);
		whline 			(pWin, ' ', lMaxX - 4);
		mvwaddstr 	(pWin, lPos+lInitY, lInitX, strBuf);
		whline			(pWin, ' ',(lInitX - strlen (strBuf)+1) / 2 - 2);
		
		wrefresh 		(pWin);
		redrawwin 	(pWin);

		/* Draw Buttons First to set correct selection */
		if (1 == lKeyPos) // Turn on INSTALL button
			wattrset 	(pWin, gtAttribute[2]);
		else              // Turn OFF INSTALL button
			wattrset 	(pWin, gtAttribute[3]);
		wmove 		(pWin, 22, 0*lSec + (lSec - strlen (STR_INSTALL))/2);
		whline 		(pWin, ' ', strlen (STR_INSTALL));
		mvwaddstr (pWin, 22, 0*lSec + (lSec - strlen (STR_INSTALL))/2, STR_INSTALL);

		if (2 == lKeyPos) // Turn on OPTION button
			wattrset 	(pWin, gtAttribute[2]);
		else              // Turn OFF OPTION button
			wattrset 	(pWin, gtAttribute[3]);
		wmove 		(pWin, 22, 1*lSec + (lSec - strlen (STR_OPTION))/2);
		whline 		(pWin, ' ', strlen (STR_OPTION));
		mvwaddstr (pWin, 22, 1*lSec + (lSec - strlen (STR_OPTION))/2, STR_OPTION);
					
		if (3 == lKeyPos) // Turn on OTHER button
			wattrset 	(pWin, gtAttribute[2]);
		else              // Turn OFF OTHER button
			wattrset 	(pWin, gtAttribute[3]);
		wmove 		(pWin, 22, 2*lSec + (lSec - strlen (STR_OTHER))/2);
		whline 		(pWin, ' ', strlen (STR_OTHER));
		mvwaddstr (pWin, 22, 2*lSec + (lSec - strlen (STR_OTHER))/2, STR_OTHER);
					
		if (4 == lKeyPos) // Turn on EXIT button
			wattrset 	(pWin, gtAttribute[2]);
		else              // Turn OFF EXIT button
			wattrset 	(pWin, gtAttribute[3]);
		wmove 		(pWin, 22, 3*lSec + (lSec - strlen (STR_EXIT))/2);
		whline 		(pWin, ' ', strlen (STR_EXIT));
		mvwaddstr (pWin, 22, 3*lSec + (lSec - strlen (STR_EXIT))/2, STR_EXIT);
		
		lRC = wgetch(pWin);
		wattrset 		(pWin, gtAttribute [1]);
		wmove 			(pWin, lPos+lInitY, 2);
		whline 			(pWin, ' ', lMaxX - 4);
		mvwaddstr 	(pWin, lPos+lInitY, lInitX, strBuf);

		switch (lRC)
		{
			case KEY_UP:
			{
				if (1 < lPos)
				{
					lPos--;
				}
				else
				{
					if (glCount-NUM_MOD_DISPLAY > lOffset)
					{
						lOffset++;
						LoadModMenu (pWin, glCount - NUM_MOD_DISPLAY - lOffset, lX, lY);
					}
				}
				if (1 < lIdx)
				{
					lIdx--;
				}
				break;
			}

			case KEY_DOWN:
			{
				if (NUM_MOD_DISPLAY > lPos)
				{
					lPos++;
				}
				else
				{
					if (0 < lOffset)
					{
						lOffset--;
						LoadModMenu	(pWin, glCount - NUM_MOD_DISPLAY - lOffset, lX, lY);
					}
				}
				if (glCount > lIdx)
				{
					lIdx++;
				}
				break;
			}
	
			case '\t':
			case KEY_RIGHT:
			{
				lKeyPos = (lKeyPos%4) + 1; /* Keep within bounds of 1->4 */
				break;
			}
			
			case KEY_LEFT:
			{
				lKeyPos--; /* Couldn't think of a smart way of doing this! :) SH20040811*/
				if (lKeyPos < 1)
					lKeyPos = 4;
				break;
			}

			case '\n':
			{
				if (4 == lKeyPos)
				{
					bExit = TRUE;
				}
				else if (3 == lKeyPos)
				{
					GetAvailOthers ();
				}
				else if (2 == lKeyPos)
				{
					char strOpt[512] = {0};
					char *pstrOpt		 = NULL;

					memset (strOpt, 0, sizeof (strOpt));

					if (TRUE == GetModuleOption (strOpt, sizeof (strOpt)))
					{
						if (0 == strlen ((pstrOpt = Strip0x20 (strOpt))))
						{
							DisplayMsg("ERROR: Module options is blank");
						}
						else
						{
							BooleanT	bSuccess		= TRUE;
							char			strCmd[600] = {0};
							char			strMsg[128] = {0};
							int				i						= 0;

							TRACE(("Begin load module with option. Mod: %s  Option: %s",
								gtAvailList[lIdx-1].pstrMods[i], pstrOpt));

							for (i=0; i<gtAvailList[lIdx-1].lModCount && TRUE == bSuccess; i++)
							{
								memset (strMsg, 0, sizeof (strMsg));
								memset (strCmd, 0, sizeof (strCmd));
								if (TRUE == gtAvailList[lIdx-1].bModNet)
								{
									sprintf(strCmd, "/bin/modprobe -f /mods/net/%s %s >> /trace/dr.log 2>&1", 
											gtAvailList[lIdx-1].pstrMods[i], pstrOpt);
								}
								else
								{
									sprintf(strCmd, "/bin/modprobe -f /mods/scsi/%s %s >> /trace/dr.log 2>&1", 
											gtAvailList[lIdx-1].pstrMods[i], pstrOpt);
								}
								TRACE(("Load Cmd='%s'", strCmd));
		
								DisplayInfo("Loading module. Please wait...");
								sleep(1);

								if (0 != system (strCmd))
								{
									snprintf(strMsg, 128, "Failed to load Mod: %s Opt:%s",
										gtAvailList[lIdx-1].pstrMods[i], pstrOpt);
									bSuccess = FALSE;
								}
								else
								{
									snprintf(strMsg, 128, "Successful load Mod: %s Opt: %s",
										gtAvailList[lIdx-1].pstrMods[i], pstrOpt);
								}
								TRACE(("End load module with option. Mod: %s  Option: %s (%s)",
									gtAvailList[lIdx-1].pstrMods[i], pstrOpt, bSuccess ? "TRUE" : "FALSE"));
								
								DisplayMsg (strMsg);
							}
						}
					}
				}
				else if (1 == lKeyPos)
				{
					char strMsg[128] = {0};
					int	 lRC = 0;
		
					if (TRUE != InstallMods (lIdx-1, &lRC) && lRC == DRMOD_ERR_FATAL)
					{
						memset (strMsg, 0, sizeof(strMsg));
						snprintf(strMsg,128, "Failed to load: %s", gtAvailList[lIdx-1].pstrDesc);
						DisplayMsg (strMsg);
					}
					else if (lRC == DRMOD_ERR_EXIST)
					{
						memset (strMsg, 0, sizeof(strMsg));
						snprintf(strMsg,128, "Module already loaded: %s",gtAvailList[lIdx-1].pstrDesc);
						DisplayMsg (strMsg);
					}
					else if (lRC == DRMOD_ERR_NONE)
					{
						memset (strMsg, 0, sizeof(strMsg));
						snprintf(strMsg, 128, "Loaded successful: %s", gtAvailList[lIdx-1].pstrDesc);
						DisplayMsg (strMsg);
					}
				}
				break;
			}
		}
	} while (TRUE != bExit);
}



/*
** =======================================================================================
** =======================================================================================
*/
static void DisplayAvailDrv ()
{
	WINDOW	*pWin			= NULL;
	int			lX				= 78;
	int			lY				= 24;
	int			lMaxX			= 0;
	int			lMaxY			= 0;
	int			i					= 0;
	int			lSec			= lX/4;

	clear 	 ();
	refresh	 ();
	getmaxyx (stdscr, lMaxY, lMaxX);

	pWin = newwin (lY, lX, (lMaxY - lY) / 2, (lMaxX - lX) / 2);

	wborder (pWin, 
					ACS_VLINE 		| gtAttribute[0], 
					ACS_VLINE 		| gtAttribute[1], 
					ACS_HLINE 		| gtAttribute[0], 
					ACS_HLINE 		| gtAttribute[1], 
					ACS_ULCORNER 	| gtAttribute[0], 
					ACS_URCORNER 	| gtAttribute[0], 
					ACS_LLCORNER 	| gtAttribute[1], 
					ACS_LRCORNER 	| gtAttribute[1]);

	wattrset (pWin, gtAttribute[1]);

	for (i=1; i<lY-1; i++)
	{
		wmove 	(pWin, i, 1);
		whline 	(pWin, ' ', lX-2);
	}
	wattrset 	(pWin, gtAttribute[3]);
	mvwaddstr (pWin, 1, (lX/2) - (strlen (STR_BAKBONE) / 2), STR_BAKBONE);
	if (TRUE == gbNicMenu)
	{
		mvwaddstr (pWin, 2, (lX/2) - (strlen (STR_NIC_TITLE) / 2), STR_NIC_TITLE);
	}
	else
	{
		mvwaddstr (pWin, 2, (lX/2) - (strlen (STR_SCSI_TITLE) / 2), STR_SCSI_TITLE);
	}
	wattrset 	(pWin, gtAttribute[1]);
	wmove 		(pWin, 3, 1);
	whline 		(pWin, ACS_HLINE, lX-2);
	wmove 		(pWin, 21, 1);
	whline 		(pWin, ACS_HLINE, lX-2);
	
	wattrset 	(pWin, gtAttribute[3]);

	mvwaddstr (pWin, 22, 0*lSec + (lSec - strlen (STR_INSTALL))/2, 	STR_INSTALL);
	mvwaddstr (pWin, 22, 1*lSec + (lSec - strlen (STR_OPTION))/2, 	STR_OPTION);
	mvwaddstr (pWin, 22, 2*lSec + (lSec - strlen (STR_OTHER))/2, 		STR_OTHER);
	mvwaddstr (pWin, 22, 3*lSec + (lSec - strlen (STR_EXIT))/2, 		STR_EXIT);

	DisplayModMenu (pWin, lX, lY);

	delwin		(pWin);
	redrawwin	(stdscr);
	refresh		();
}


/*
** =======================================================================================
** Function to clean up memory allocated in global variables
** =======================================================================================
*/
static void CleanupMemory()
{
	int i = 0;
	int iMod = 0;
	for (i = 0; i < glCount; i++)
	{
		if (NULL != gtAvailList[i].pstrComp)
			free(gtAvailList[i].pstrComp);
		if (NULL != gtAvailList[i].pstrDesc)
			free(gtAvailList[i].pstrDesc);
		
		gtAvailList[i].pstrComp = NULL;
		gtAvailList[i].pstrDesc = NULL;

		for (iMod = 0; iMod < gtAvailList[i].lModCount; iMod++)
		{
			if (NULL != gtAvailList[i].pstrMods[iMod])
				free(gtAvailList[i].pstrMods[iMod]);
			gtAvailList[i].pstrMods[iMod] = NULL;
		}
	}
	glCount = 0;
}

/*
** =======================================================================================
** Exported function to allow User to Manually Load a NIC module
** Parameters:
**     tLoadedModList - a fixed array size (50) to contain modules user tried to load
**     lNumEntries    - number of existing entries in the above array to prevent
**                      overwriting
** Return:
**     Number of valid entries including what was already in the tLoadedModList array.
** =======================================================================================
*/
extern long BeginNICUserGUI( ModListT tLoadedModList[], long lNumEntries )
{
	gpLoadedModList = tLoadedModList;
	glNumLoadedCnt  = lNumEntries;
	gbNicMenu       = TRUE;
	
	WinInit();

	if (TRUE != ParseModTxtFile ("/bin/drnic.txt", TRUE))
	{
		DisplayMsg ("ERROR: Failed to load /bin/drnic.txt");
	}
	else
	{
		DisplayAvailDrv();
	}

	/* Clean up memory allocated in global variables */
	CleanupMemory();

	TRACE(("Returning from BeginMODUserGUI: EntryCount = %ld", glNumLoadedCnt)); 
	return glNumLoadedCnt;
}



/*
** =======================================================================================
** Exported function to allow User to Manually Load a SCSI module
** Parameters:
**     tLoadedModList - a fixed array size (50) to contain modules user tried to load
**     lNumEntries    - number of existing entries in the above array to prevent
**                      overwriting
** Return:
**     Number of valid entries including what was already in the tLoadedModList array.
** =======================================================================================
*/
extern long BeginSCSIUserGUI( ModListT tLoadedModList[], long lNumEntries )
{
	gpLoadedModList = tLoadedModList;
	glNumLoadedCnt  = lNumEntries;
	gbNicMenu       = FALSE;
	
	WinInit();

	if (TRUE != ParseModTxtFile ("/bin/drscsi.txt", FALSE))
	{
		DisplayMsg ("ERROR: Failed to load /bin/drscsi.txt");
	}
	else
	{
		DisplayAvailDrv();
	}

	/* Clean up memory allocated in global variables */
	CleanupMemory();

	TRACE(("Returning from BeginMODUserGUI: EntryCount = %ld", glNumLoadedCnt)); 
	return glNumLoadedCnt;
}

