#include <sys/types.h>

#define MAX_MOD_DEPEND_COUNT	5
#define MAX_MOD_ARRAY_SIZE    50
#define DR_MOD_EXT            ".ko"

typedef struct
{
	char			*pstrDesc;                      /* General description of what hardware it supports*/
	char      *pstrComp;                      /* Company Name of who created Module*/
	char			*pstrMods[MAX_MOD_DEPEND_COUNT];/* List of modules to load (include dependencies) */
	long			lModCount;                      /* Number of dependencies in pstrMods*/
	long			lRC;                            /* Error code from loading this module*/
	BooleanT	bModNet;                        /* Is this NIC or SCSI module*/
} ModListT;

typedef enum
{
	DrYes = 0,
	DrNo  = 1
} DrRequestE;


/*
** =======================================================================================
** Exported function to allow User to Manually Load modules
** Parameters:
**     tLoadedModList - a fixed array size (50) to contain modules user tried to load
**     lNumEntries    - number of existing entries in the above array to prevent
**                      overwriting
** Return:
**     Number of valid entries including what was already in the tLoadedModList array.
** =======================================================================================
*/
extern long BeginNICUserGUI( ModListT tLoadedModList[], 
                             long     lNumEntries);
extern long BeginSCSIUserGUI( ModListT tLoadedModList[], 
                             long     lNumEntries);
