
#ifndef DRPG_H
#define DRPG_H

typedef struct tPing PingT;


struct tPing
{
  int    	lSock;
  int    	lType;
  int    	lCount;
  int    	lInterval;
  char   	*pstrHost;
  size_t 	lBufLen;
  int    	lIdent;
  int 		lBufCkLen;
  char   	*pBufferCk;
  u_char 	*pBuffer;
  long   	lNumXmit;
  long   	lNumRecv;
  struct 	sockaddr_in tSockAddrPeer;
  struct 	sockaddr_in tSockAddrDest;
};

#define	MAX_WAIT_SECS					10
#define	PING_CKTABSIZE 				128
#define	ICMP_ECHOREPLY				0
#define	ICMP_ECHO							8
#define ICMP_TIMESTAMPREPLY		14
#define ICMP_ADDRESSREPLY			18
#define	ICMP_MINLEN						8

#define	PG_HDR_LEN				sizeof(struct timeval)
#define	PG_DATA_LEN				(64 - PG_HDR_LEN)
#define PG_BUFFER_LEN(p) 	((p)->lBufLen + sizeof (icmphdr_t))

#define PG_C_BIT(p,bit)  	(p)->pBufferCk[(bit)>>3]
#define PG_C_MASK(bit)   	(1 << ((bit) & 0x07))
#define PG_C_CLR(p,bit) 	(PG_C_BIT (p,bit) &= (~PG_C_MASK (bit)))
#define PG_C_SET(p,bit) 	(PG_C_BIT (p,bit) |= PG_C_MASK (bit))
#define PG_C_TST(p,bit) 	(PG_C_BIT (p,bit) & PG_C_MASK (bit))


typedef struct icmp_header icmphdr_t;

struct icmp_header
{
  u_char  icmp_type;
  u_char  icmp_code;
  u_short icmp_cksum;
  union
  {
    u_char ih_pptr;
    struct in_addr ih_gwaddr;
    struct ih_idseq
    {
      u_short	icd_id;
      u_short	icd_seq;
    } ih_idseq;
    int ih_void;

    struct ih_pmtu
    {
      u_short ipm_void;
      u_short ipm_nextmtu;
    } ih_pmtu;

    struct ih_rtradv
    {
      u_char irt_num_addrs;
      u_char irt_wpa;
      u_short irt_lifetime;
    } ih_rtradv;
    
  } icmp_hun;

#define	icmp_id		icmp_hun.ih_idseq.icd_id
#define	icmp_seq	icmp_hun.ih_idseq.icd_seq
  
  union
  {
    struct id_ts
    {
      n_time its_otime;
      n_time its_rtime;
      n_time its_ttime;
    } id_ts;
    struct id_ip
    {
      struct ip idi_ip;
    } id_ip;
    u_long	id_mask;
    char	id_data[1];
  } icmp_dun;
#define	icmp_data	icmp_dun.id_data
};

#endif
