
#include "drtrace.h"


static FILE *gpFile	= NULL;


/*
** ============================================================================
** ============================================================================
*/
extern void DrTraceInit (BooleanT bTrunc)
{
  struct stat tStat;
  int         lRC         = -1;
  int         lFd         = -1;
  long        lError      = -1;
  BooleanT    bFileExist  = TRUE;
  FILE        *pFile      = NULL;

  memset (&tStat, 0, sizeof (tStat));

  if (-1 == (lRC = stat (DR_TRACE_FILE, &tStat)))
  {
		lError = errno;

    if (2 == lError)
    {
      bFileExist = FALSE;

      lFd = open (DR_TRACE_FILE, O_WRONLY | O_CREAT | O_TRUNC, 0666);
    }
    else
    {
      fprintf(stderr,"ERROR: Failed to stat file: %s. %s\n", 
			DR_TRACE_FILE, strerror(lError));
    }
  }
  else if (0 == tStat.st_size)
  {
    lFd = open (DR_TRACE_FILE, O_WRONLY | O_APPEND | O_TRUNC, 0666);
  }
  else
  {
		bTrunc ?
    (lFd = open (DR_TRACE_FILE, O_WRONLY | O_TRUNC, 0666)) :
    (lFd = open (DR_TRACE_FILE, O_WRONLY | O_APPEND, 0666));
  }
  lError = errno;

  if (-1 == lFd)
  {
    fprintf(stderr,"ERROR: Failed to open-1 file: %s. %s\n", 
		DR_TRACE_FILE, strerror(lError));
  }
  else if (TRUE == bFileExist && NULL == (pFile = fdopen (lFd, "a")))
  {
    lError = errno;
    fprintf(stderr,"ERROR: Failed to open-2 file: %s. %s\n", 
		DR_TRACE_FILE, strerror(lError));
  }
  else if (TRUE != bFileExist && NULL == (pFile = fdopen (lFd, "w")))
  {
    lError = errno;
    fprintf(stderr,"ERROR: Failed to open-3 file: %s. %s\n", 
		DR_TRACE_FILE, strerror(lError));
  }
  else
  {
    gpFile = pFile;
  }
}




/*
** ============================================================================
** ============================================================================
*/
extern void DrTrace (const char *pstrMod, const char *pstrFormat, va_list args)
{
  if (NULL != gpFile)
  {
		char			strMod[9] = {0};
		memset		(strMod, 0, 9);
		strncpy		(strMod, pstrMod, 8);
    fprintf   (gpFile, "%-8s: ", strMod);
    vfprintf  (gpFile, pstrFormat, args);
    fprintf   (gpFile, "\n");
    fflush    (gpFile);
  }
}

