
#ifndef DRTRACE_H
#define DRTRACE_H

#include <stdio.h>
#include <stdarg.h>
#include <stdlib.h>
#include <string.h>
#include <fcntl.h>
#include <sys/stat.h>
#include <sys/errno.h>
#include <sys/types.h>

typedef long            BooleanT;
#define DR_TRACE_FILE   "/trace/dr.log"
#define TRUE            1
#define FALSE           0
#define MODULE(x) 			MODULE_IN(x "        ")
#define TRACE(x) 				DrTraceTmp x

#define MODULE_IN(MODULE_ID) \
static void DrTraceTmp (const char *pstrFormat, ...) \
{ \
  static const char *pstrMod = MODULE_ID; \
  va_list            args; \
 \
  va_start(args, pstrFormat); \
  DrTrace (pstrMod, pstrFormat, args); \
  va_end(args); \
} \


extern void DrTraceInit (BooleanT);
extern void DrTrace 		(const char *, const char *, va_list);

#endif
